package de.aristaflow.adept2.core.checks.processmodel.timemodel;

import org.apache.commons.configuration.Configuration;

import de.aristaflow.adept2.base.service.AbstractADEPT2Service;
import de.aristaflow.adept2.base.service.Registry;
import de.aristaflow.adept2.core.checks.processmodel.ProcessCheckService;
import de.aristaflow.adept2.core.checks.processmodel.ProcessTemplateCheck;

public class DefaultTimedProcessModelCheckService extends AbstractADEPT2Service
    implements TemporalProcessCheckService, ProcessCheckService
{

  private Configuration configuration;

  public DefaultTimedProcessModelCheckService(Configuration configuration,
      Registry registry)
  {
    super(configuration, registry);
    this.configuration = configuration;
  }


  public ProcessTemplateCheck getExecutionProductionChecks()
  {
    return new BasicTemporalProcessCheck(configuration, this, registry);
  }

  public ProcessTemplateCheck getExecutionTestClientChecks()
  {
    return new BasicTemporalProcessCheck(configuration, this, registry);
  }

  public ProcessTemplateCheck getProcessTemplateStructureChecks()
  {
    return new BasicTemporalProcessCheck(configuration, this, registry);
  }


  @Override
  public ProcessTemplateCheck getProcessTemplateCheck(String checkID)
  {
    return getProcessTemplateStructureChecks();
  }


  @Override
  public ProcessTemplateCheck getConsistencyChecks()
  {
    return getProcessTemplateStructureChecks();
  }


  @Override
  public ProcessTemplateCheck getStructureChecks()
  {
    return getProcessTemplateStructureChecks();
  }


  @Override
  public ProcessTemplateCheck getBasicModellingChecks()
  {
    return getProcessTemplateStructureChecks();
  }

}
