package de.aristaflow.adept2.core.checks.timemodel.tcnimplementation;

import org.apache.commons.configuration.Configuration;

import de.aristaflow.adept2.base.service.AbstractADEPT2Service;
import de.aristaflow.adept2.base.service.Registry;
import de.aristaflow.adept2.core.checks.timemodel.TimeModelCheck;
import de.aristaflow.adept2.core.checks.timemodel.TimeModelCheckRunner;
import de.aristaflow.adept2.core.checks.timemodel.TimeModelCheckService;

public class TCNTimModelCheckService extends AbstractADEPT2Service implements TimeModelCheckService
{

  private Configuration configuration;

  public TCNTimModelCheckService(Configuration configuration, Registry registry)
  {
    super(configuration, registry);
    this.configuration = configuration;
  }
  
  public TCNTimModelCheckService(Configuration configuration, Registry registry,
      String[] startupRequiredServices, String[] runtimeRequiredServices)
  {
    super(configuration, registry, startupRequiredServices, runtimeRequiredServices);
    this.configuration = configuration;
  }

  public TimeModelCheck getExecutionProductionChecks()
  {
    return new TimeModelCheckRunner(new TCNTimeModelConsistencyCheck(configuration, this, registry));
  }

  public TimeModelCheck getExecutionTestClientChecks()
  {
    return new TimeModelCheckRunner(new TCNTimeModelConsistencyCheck(configuration, this, registry));
  }

}
