package de.aristaflow.adept2.core.checks.timemodel.tcnimplementation;


import org.apache.commons.configuration.Configuration;

import de.aristaflow.adept2.base.service.Registry;
import de.aristaflow.adept2.core.checks.timemodel.TimeModelCheck;
import de.aristaflow.adept2.core.checks.timemodel.TimeModelCheckService;
import de.aristaflow.adept2.model.processmodel.Template;
import de.aristaflow.adept2.model.processmodel.tools.NodeRelations;
import de.aristaflow.adept2.model.timemodel.InconsistencyException;
import de.aristaflow.adept2.model.timemodel.TimeModel;
import de.aristaflow.adept2.model.timemodel.TimeModelSolver;
import de.aristaflow.adept2.util.CheckReport.ResultType;

public class TCNTimeModelConsistencyCheck extends AbstractTimeModelCheck implements TimeModelCheck
{

  public TCNTimeModelConsistencyCheck(Configuration configuration,
      TimeModelCheckService checkService, Registry registry)
  {
    super("TCNTimeModelConsistencyCheck", configuration, checkService, registry);
  }

  @Override
  protected void performCheckSpi(TimeModel timeModel, Template template,
      NodeRelations relations)
  {
    TimeModelSolver timeModelSolver = factory.getTimeModelSolver(timeModel.getClass());
    try
    {
      try
      {
        timeModelSolver.solve(timeModel);
      }
      catch (InterruptedException e)
      {
        // Log but otherwise ignore...
        //e.printStackTrace();
        
      }
    }
//    catch (TCNInconsistencyException e)
//    {
//      addReportEntry(ResultType.FAILURE, "Inconsistent Time Model", e.getStartEvent(), e.getEndEvent());
//    }
    catch (InconsistencyException e)
    {
      addReportEntry(ResultType.FAILURE, "Inconsistent Time Model");
    }
  }

}
