package de.aristaflow.adept2.core.timemanager;

import java.util.UUID;

import de.aristaflow.adept2.base.communication.annotations.ProxyAllow;
import de.aristaflow.adept2.base.service.ADEPT2Service;
import de.aristaflow.adept2.base.sessionmanagement.SessionToken;
import de.aristaflow.adept2.model.timemodel.InstanceTimeContext;
import de.aristaflow.adept2.model.timemodel.InstanceTimeModel;
import de.aristaflow.adept2.model.timemodel.TimeModelStatus;
import de.aristaflow.adept2.util.DataSourceException;

/*
 */
@ProxyAllow
public interface InstanceTimeManager
{
  /* {src_lang=Java} */

  /**
   * @uml.property  name="instanceTimeContext"
   * @uml.associationEnd  readOnly="true" inverse="timeManager:de.aristaflow.adept2.core.timemanager.InstanceTimeContext"
   */
  public InstanceTimeContext getInstanceTimeContext(SessionToken sessionToken,
      UUID instanceID);

  /**
   * @uml.property  name="timePrediction"
   * @uml.associationEnd  readOnly="true" inverse="timeManager:de.aristaflow.adept2.core.timemanager.TimePrediction"
   */
  public TimePrediction getTimePrediction(SessionToken sessionToken,
      UUID instanceID);

  InstanceTimeModel getInstanceTimeModelReadonly(SessionToken session, UUID instanceID) throws DataSourceException;

  TimeModelStatus getTimeModelStatusReadonly(UUID instanceID);


}