package de.aristaflow.adept2.model.common.timedata;

import de.aristaflow.adept2.model.common.viewer.Attribute;
import de.aristaflow.adept2.model.common.viewer.AttributeSetter;

/** 
 *  <p>
 *  This is just a wrapper for a <code>java.util.Calendar</code> to be used with PluginDataContainers.<br />
 *  A <code>CalendarElement</code> is always in the Servers default time zone.</p>
 */
public interface CalendarElement {
  /* {src_lang=Java}*/


  /** 
   *  Returns this Calendar's time value in milliseconds.
   *  
   *  @return the current time as UTC milliseconds from the epoch.
   */
  @Attribute(name="TimeInMillis",defaultValue="-1")
  public long getTimeInMillis();

  @AttributeSetter("TimeInMillis")
  public void setTimeInMillis(long timeInMillis);

}