package de.aristaflow.adept2.model.common.timedata;

import de.aristaflow.adept2.model.common.viewer.Attribute;
import de.aristaflow.adept2.model.common.viewer.AttributeSetter;
import de.aristaflow.adept2.model.timemodel.TimeModelStatus.TimeModelState;

public interface WorklistItemTimeContext
{

  public static final String ID = "TimeContext";
  
  
  @Attribute(name="EarliestStartTime")
  CalendarElement getEarliestStartTime();
  
  @Attribute(name="LatestStartTime")
  CalendarElement getLatestStartTime();

  @Attribute(name="EarliestCompletionTime")
  CalendarElement getEarliestCompletionTime();

  @Attribute(name="LatestCompletionTime")
  CalendarElement getLatestCompletionTime();

  @Attribute(name="TimeModelStatus")
  TimeModelState getTimeModelStatus();
  
  
  @Attribute(name="MinimumDurationRestriction")
  TimePoint getMinimumDurationRestriction();

  
  @Attribute(name="MaximumDurationRestriction")
  TimePoint getMaximumDurationRestriction();
  
  @AttributeSetter("MinimumDurationRestriction")
  void setMinimumDurationRestriction(TimePoint duration);

  @AttributeSetter("MaximumDurationRestriction")
  void setMaximumDurationRestriction(TimePoint duration);

//  @AttributeSetter("DurationRestriction")
//  void setDurationRestriction(Interval<TimePoint> duration);
  
  @AttributeSetter("EarliestStartTime")
  void setEarliestStartTime(CalendarElement timePoint);
  
  @AttributeSetter("LatestStartTime")
  void setLatestStartTime(CalendarElement timePoint);

  @AttributeSetter("EarliestCompletionTime")
  void setEarliestCompletionTime(CalendarElement timePoint);

  @AttributeSetter("LatestCompletionTime")
  void setLatestCompletionTime(CalendarElement timePoint);

  @AttributeSetter("TimeModelStatus")
  void setTimeModelStatus(TimeModelState timeModelStatus);
  


}
