package de.aristaflow.adept2.model.common.timedata.defaultimplementation;

import java.text.SimpleDateFormat;
import java.util.Calendar;

import de.aristaflow.adept2.model.common.timedata.CalendarElement;

public class DefaultCalendarElement implements CalendarElement
{

  private long timeInMillis;

  public DefaultCalendarElement(long timeInMillis)
  {
    if (timeInMillis < 0)
      throw new IllegalArgumentException("timeInMillis cannot be negativ!");
    
    this.timeInMillis = timeInMillis;
  }

  public long getTimeInMillis()
  {
    return this.timeInMillis;
  }

  public void setTimeInMillis(long timeInMillis)
  {
    this.timeInMillis = timeInMillis;
  }
  
  @Override
  public String toString()
  {
    Calendar calendar = Calendar.getInstance();
    calendar.setTimeInMillis(timeInMillis);
    
    SimpleDateFormat df = new SimpleDateFormat( "HH:mm:ss" );
    
    return df.format(calendar.getTime());
//    return (timeInMillis / 1000)+"s";
  }

  @Override
  public int hashCode()
  {
    return (int)this.timeInMillis;
  }

  @Override
  public boolean equals(Object obj)
  {
    if (this == obj)
      return true;
    
    if (obj instanceof DefaultCalendarElement)
    {
      DefaultCalendarElement other = (DefaultCalendarElement) obj;
      return this.timeInMillis == other.timeInMillis;
    }
    
    return super.equals(obj);
  }
  
  

}
