package de.aristaflow.adept2.model.processmodel;

import de.aristaflow.adept2.model.common.viewer.Attribute;
import de.aristaflow.adept2.model.processmodel.timemodel.ActivityDuration;
import de.aristaflow.adept2.model.processmodel.timemodel.FixedDate;
import de.aristaflow.adept2.model.processmodel.timemodel.NodeTemporalInformation;
import de.aristaflow.adept2.model.processmodel.timemodel.ScheduleRestrictedElement;
import de.aristaflow.adept2.model.processmodel.timemodel.ValidityPeriod;

public interface TemporalNode extends Node
{
  
  ActivityDuration getActivityDuration();
  
  FixedDate getStartFixedDate();
  
  FixedDate getCompletionFixedDate();
  
  ScheduleRestrictedElement getStartSchedule();
  
  ScheduleRestrictedElement getCompletionSchedule();
  
  ValidityPeriod getStartValidityPeriod(); 
  
  ValidityPeriod getCompletionValidityPeriod();
}
