package de.aristaflow.adept2.model.processmodel;

import java.util.Set;

import de.aristaflow.adept2.model.globals.TimeModelConstants.RelationType;
import de.aristaflow.adept2.model.processmodel.timemodel.FixedDate;
import de.aristaflow.adept2.model.processmodel.timemodel.ProcessDuration;
import de.aristaflow.adept2.model.processmodel.timemodel.ScheduleRestrictedElement;
import de.aristaflow.adept2.model.processmodel.timemodel.TimeLag;
import de.aristaflow.adept2.model.processmodel.timemodel.ValidityPeriod;

public interface TemporalTemplate extends Template
{
  
  ProcessDuration getProcessDuration();
   
  FixedDate getStartFixedDate();
  
  FixedDate getCompletionFixedDate();
  
  ScheduleRestrictedElement getStartScheduleRestrictedElement();
  
  ScheduleRestrictedElement getCompletionScheduleRestrictedElement();
  
  ValidityPeriod getStartValidityPeriod(); 
  
  ValidityPeriod getCompletionValidityPeriod();
  
  public TimeLag getTimeLagConstraint(int srcNodeID, int destNodeID, RelationType relationType);
  
  public TimeLag[] getTimeLagsConstraint(int srcNodeID, int destNodeID);
  
  public TemporalNode getNode(int nodeID);
  
  public Set<TemporalNode> getTemporalNodes();
  
}
