package de.aristaflow.adept2.model.processmodel.algorithms.sesedecomposition;

/**
 * Helper class to compute the Cycle Equivalence classes of an undirected graph (see {@link CycleEquivalence})
 * 
 * This class uniquely identifies a Cycle Equivalence class.
 * 
 * @author lanz
 *
 */
class CQClass
{

  private EdgeStruct edge;
  private int number;

  public CQClass(EdgeStruct edge, int number)
  {
    this.edge = edge;
    this.number = number;
  }
  
  @Override
  public String toString()
  {
    return "<"+edge+", "+number+">";
  }
  

  @Override
  public int hashCode()
  {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((edge == null) ? 0 : edge.hashCode());
    result = prime * result + number;
    return result;
  }

  @Override
  public boolean equals(Object obj)
  {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    CQClass other = (CQClass) obj;
    if (edge == null)
    {
      if (other.edge != null)
        return false;
    }
    else if (!edge.equals(other.edge))
      return false;
    if (number != other.number)
      return false;
    return true;
  }
  
}