package de.aristaflow.adept2.model.processmodel.algorithms.sesedecomposition;

/**
 * Helper class to compute the Cycle Equivalence classes of an undirected graph (see {@link CycleEquivalence}).
 * 
 * This class represents an edge in the undirected graph with necessary additional information.
 * 
 * @author lanz
 *
 */
class EdgeStruct
{
  
  protected NodeStruct n1;
  protected NodeStruct n2;


  /** EQClass(e:node): integer : Cycle-equivalency class of edge */
  public CQClass CQclass;
  /** RecentSize(e:edge): integer : Size of bracket set when e was most recently the topmost bracket for a representative node */
  public int recentSize = -1;
  /** RecentClass(e:edge): integer : Cycle-equivalency class number of representative node for which e was most recently the topmost bracket. */
  public CQClass recentClass;
  
  public RegionStruct entryRegion;
  public RegionStruct exitRegionStruct;

  public EdgeStruct(NodeStruct n1, NodeStruct n2)
  {
    this.n1 = n1;
    this.n2 = n2;
    
  }
  
  
  @Override
  public String toString()
  {
    return n1+"--"+n2;
  }
  
}