package de.aristaflow.adept2.model.processmodel.defaultimplementation;

import java.util.Map;
import java.util.Set;
import java.util.UUID;

import de.aristaflow.adept2.model.common.PluginData;
import de.aristaflow.adept2.model.globals.ActivityConstants.AccessType;
import de.aristaflow.adept2.model.processmodel.ExecutableBusinessProcess;
import de.aristaflow.adept2.model.processmodel.Node;
import de.aristaflow.adept2.model.processmodel.ProcessModelParameter;

@SuppressWarnings("deprecation")
public abstract class AbstractWrappingNode implements Node
{

  private final Node node;
  
  protected AbstractWrappingNode(Node baseNode)
  {
    this.node = baseNode;
  }

  protected Node getNode()
  {
    return node;
  }

  public Map<String, Set<String>> getSupportedPlugins()
  {
    return this.node.getSupportedPlugins();
  }

  public String getUserAttributeValue(String attributeName)
  {
    return this.node.getUserAttributeValue(attributeName);
  }

  public Map<String, PluginData> getPluginDatas()
  {
    return this.node.getPluginDatas();
  }
  
  public void setUserAttributeValue(String attributeName, String attributeValue)
  {
    this.node.setUserAttributeValue(attributeName, attributeValue);
  }

  public int getID()
  {
    return this.node.getID();
  }

  public PluginData getPluginData(String pluginID)
  {
    return this.node.getPluginData(pluginID);
  }

  public String getName()
  {
    return this.node.getName();
  }

  public void removeUserAttributeValue(String attributeName)
  {
    this.node.removeUserAttributeValue(attributeName);
  }

  public UUID getIconID()
  {
    return this.node.getIconID();
  }

  public ExecutableBusinessProcess getExecutableBusinessProcess()
  {
    return this.node.getExecutableBusinessProcess();
  }

  public Map<String, String> getUserAttributes()
  {
    return this.node.getUserAttributes();
  }

  public int getConnector(String parameterName, AccessType accessType)
  {
    return this.node.getConnector(parameterName, accessType);
  }

  public String getParameterName(int connectorID)
  {
    return this.node.getParameterName(connectorID);
  }

  public Map<String, Integer> getConnectorMapping(AccessType accessType)
  {
    return this.node.getConnectorMapping(accessType);
  }

  public String getDescription()
  {
    return this.node.getDescription();
  }

  public String getStaffAssignmentRule()
  {
    return this.node.getStaffAssignmentRule();
  }

  public ProcessModelParameter getSystemParameter(String name,
      AccessType accessType)
  {
    return this.node.getSystemParameter(name, accessType);
  }

  public Set<ProcessModelParameter> getSystemParameters(AccessType accessType)
  {
    return this.node.getSystemParameters(accessType);
  }

  public boolean isAutoStartEnabled()
  {
    return this.node.isAutoStartEnabled();
  }

}
