package de.aristaflow.adept2.model.processmodel.defaultimplementation;

import de.aristaflow.adept2.model.processmodel.Node;
import de.aristaflow.adept2.model.processmodel.TemporalNode;
import de.aristaflow.adept2.model.processmodel.timemodel.ActivityDuration;
import de.aristaflow.adept2.model.processmodel.timemodel.FixedDate;
import de.aristaflow.adept2.model.processmodel.timemodel.ScheduleRestrictedElement;
import de.aristaflow.adept2.model.processmodel.timemodel.TimeModelTools;
import de.aristaflow.adept2.model.processmodel.timemodel.ValidityPeriod;

public class DefaultTemporalNode extends AbstractWrappingNode implements
    TemporalNode
{

  public DefaultTemporalNode(Node baseNode)
  {
    super(baseNode);
  }

  public ActivityDuration getActivityDuration()
  {
    return TimeModelTools.getActivityDuration(getNode());
  }

  public FixedDate getStartFixedDate()
  {
    return TimeModelTools.getStartFixedDate(getNode());
  }

  public FixedDate getCompletionFixedDate()
  {
    return TimeModelTools.getCompletionFixedDate(getNode());
  }

  public ScheduleRestrictedElement getStartSchedule()
  {
    return TimeModelTools.getStartSchedule(getNode());
  }

  public ScheduleRestrictedElement getCompletionSchedule()
  {
    return TimeModelTools.getCompletionSchedule(getNode());
  }

  public ValidityPeriod getStartValidityPeriod()
  {
    return TimeModelTools.getStartValidityPeriod(getNode());
  }

  public ValidityPeriod getCompletionValidityPeriod()
  {
    return TimeModelTools.getCompletionValidityPeriod(getNode());
  }
  
  @Override
  public String toString()
  {
    return getNode().toString();
  }

}
