package de.aristaflow.adept2.model.processmodel.timemodel;

import de.aristaflow.adept2.model.common.PluginData;
import de.aristaflow.adept2.model.common.viewer.Attribute;
import de.aristaflow.adept2.model.common.viewer.AttributeSetter;

/**
 * Plug-in Data for the update of the duration restriction of a process step.
 */
public interface ActivityDurationUpdateProcedureData {
  /* {src_lang=Java, java_import=de.aristaflow.adept2.model.common.viewer.Attribute, java_import=de.aristaflow.adept2.model.common.viewer.AttributeSetter}*/


  
  /**
   * @returns   The Plug-in ID of the activity duration update handler procedure
   * @uml.property  name="procedureID"
   */
  @Attribute(name="ActivityDurationUpdateProcedureID")
  public String getProcedureID();

  /**
   * <p>Update trigger tell the time manager when to call the respective ActivityDurationUpdateProcedure. That is, if one of the events specified by the update trigger list occurrs during proces execution the respective ActivityDurationUpdateHandler will be call with the respective ProcessEventReference as trigger.</p>
   * @returns   A List of ProcessEventReferences which shall be used as update triggers for the activity duration.
   * @uml.property  name="updateTriggerList"
   * @uml.associationEnd  multiplicity="(0 -1)" container="de.aristaflow.adept2.model.common.PluginData"
   */
  @Attribute(name="UpdateTriggerList")
  public PluginData[] getUpdateTriggerList();

  /**
   * @param  id
   * @uml.property  name="procedureID"
   */
  @AttributeSetter("ActivityDurationUpdateProcedureID")
  public void setProcedureID(String id);

  /**
   * @param  list
   * @uml.property  name="updateTriggerList"
   */
  @AttributeSetter("UpdateTriggerList")
  public void setUpdateTriggerList(PluginData[] list);

}