package de.aristaflow.adept2.model.processmodel.timemodel;

import java.util.UUID;

/** 
 *  <p>This interface provides a reference to an activity-instance of a process instance. The activity is identified by
 *  <ul>
 *  <li>the process template</li>
 *  <li>the process instance</li>
 *  <li>the node ID</li>
 *  <li>the node iteration.<li>
 *  <ul>
 *  An <code>ActivityReference</code> can therefore be used to uniquely identify an activity within a process.</p>
 */
public interface ActivityInstanceReference extends ActivityReference {
  /* {src_lang=Java}*/


  /** 
   *  @returns the iteration count of the reference activity-instance
   */
  public int getNodeIteration();

  /** 
   *  @returns the instance ID of the process instance the reference activity instance belongs to
   */
  public UUID getInstanceID();

}