package de.aristaflow.adept2.model.processmodel.timemodel;

import java.util.UUID;

/** 
 *  <p>This interface provides a reference to an activity, i.e., a node, of a process template. The activity is identified by
 *  <ul>
 *  <li>the process template</li>
 *  <li>the node ID</li>
 *  <ul>
 *  An <code>ActivityReference</code> can therefore be used to uniquely identify an activity within a process.</p>
 */
public interface ActivityReference {
  /* {src_lang=Java}*/


  /** 
   *  @returns the ID of the process template the reference activity belongs to.
   */
  public UUID getTemplateID();

  /** 
   *  @returns the node Id of the reference activity within the process template
   */
  public int getNodeID();

}