package de.aristaflow.adept2.model.processmodel.timemodel;

import de.aristaflow.adept2.model.common.viewer.Attribute;
import de.aristaflow.adept2.model.common.viewer.AttributeSetter;

public interface NodeTemporalInformation
{
  
  public static final String ID = "TimeData.NodeTemporalInformation";
  
  @Attribute(name="ActivityDuration")
  ActivityDuration getActivityDuration();
  
  @Attribute(name="StartFixedDate")
  FixedDate getStartFixedDate();
  
  @Attribute(name="CompletionFixedDate")
  FixedDate getCompletionFixedDate();
  
  @Attribute(name="StartSchedule")
  ScheduleRestrictedElement getStartSchedule();
  
  @Attribute(name="CompletionSchedule")
  ScheduleRestrictedElement getCompletionSchedule();
  
  @Attribute(name="StartValidityPeriod")
  ValidityPeriod getStartValidityPeriod(); 
  
  @Attribute(name="CompletionValidityPeriod")
  ValidityPeriod getCompletionValidityPeriod();

  @AttributeSetter("ActivityDuration")
  void setActivityDuration(ActivityDuration activityDuration);

  @AttributeSetter("StartFixedDate")
  void setStartFixedDate(FixedDate startFixeDate);

  @AttributeSetter("CompletionFixedDate")
  void setCompletionFixedDate(FixedDate completionFixeDate);

  @AttributeSetter("StartSchedule")
  void setStartSchedule(ScheduleRestrictedElement startSchedule);

  @AttributeSetter("CompletionSchedule")
  void setCompletionSchedule(ScheduleRestrictedElement completionSchedule);

  @AttributeSetter("StartValidityPeriod")
  void setStartValidityPeriod(ValidityPeriod startValidityPeriod);

  @AttributeSetter("CompletionValidityPeriod")
  void setCompletionValidityPeriod(ValidityPeriod completionValidityPeriod);
  
  
}
