package de.aristaflow.adept2.model.processmodel.timemodel;

import de.aristaflow.adept2.model.common.viewer.Attribute;
import de.aristaflow.adept2.model.common.viewer.AttributeSetter;

public interface TemplateTemporalInformation
{
  public static final String ID = "TimeData.TemplateTemporalInformation";
  
  @Attribute(name="ProcessDuration")
  ProcessDuration getProcessDuration();
   
  @Attribute(name="StartFixedDate")
  FixedDate getStartFixedDate();
  
  @Attribute(name="CompletionFixedDate")
  FixedDate getCompletionFixedDate();
  
  @Attribute(name="StartScheduleRestrictedElement")
  ScheduleRestrictedElement getStartScheduleRestrictedElement();
  
  @Attribute(name="CompletionScheduleRestrictedElement")
  ScheduleRestrictedElement getCompletionScheduleRestrictedElement();
  
  @Attribute(name="StartValidityPeriod")
  ValidityPeriod getStartValidityPeriod(); 
  
  @Attribute(name="CompletionValidityPeriod")
  ValidityPeriod getCompletionValidityPeriod();

  @AttributeSetter("ProcessDuration")
  void setProcessDuration(ProcessDuration processDuration);

  @AttributeSetter("StartValidityPeriod")
  void setStartValidityPeriod(ValidityPeriod startValidityPeriod);

  @AttributeSetter("CompletionValidityPeriod")
  void setCompletionValidityPeriod(ValidityPeriod completionValidityPeriod);

  @AttributeSetter("StartFixedDate")
  void setStartFixedDate(FixedDate startFixedDate);

  @AttributeSetter("CompletionFixedDate")
  void setCompletionFixedDate(FixedDate completionFixedDate);

  @AttributeSetter("StartScheduleRestrictedElement")
  void setStartSchedule(ScheduleRestrictedElement startSchedule);

  @AttributeSetter("CompletionScheduleRestrictedElement")
  void setCompletionSchedule(ScheduleRestrictedElement completionSchedule);
}
