package de.aristaflow.adept2.model.processmodel.timemodel.defaultimplementation;

import java.io.Serializable;

import de.aristaflow.adept2.model.common.PluginData;
import de.aristaflow.adept2.model.common.timedata.TimePoint;
import de.aristaflow.adept2.model.processmodel.timemodel.ActivityDuration;
import de.aristaflow.adept2.model.processmodel.timemodel.ActivityDurationUpdateProcedureData;

public class DefaultActivityDuration implements ActivityDuration, Serializable
{

  /**
   * 
   */
  private static final long serialVersionUID = -1074117438602963943L;
  
  private TimePoint flexibleMinimumDuration;
  private TimePoint guardMinimumDuration;
  private TimePoint guardMaximumDuration;
  private TimePoint flexibleMaximumDuration;
  private TimePoint expectedDuration;
  private TimePoint contingency;
  

  public DefaultActivityDuration()
  {
    
  }

  public TimePoint getMinimumDuration()
  {
    return flexibleMinimumDuration;
  }
  
  public TimePoint getGuardMinimumDuration()
  {
    return guardMinimumDuration;
  }

  public TimePoint getGuardMaximumDuration()
  {
    return guardMaximumDuration;
  }

  public TimePoint getMaximumDuration()
  {
    return flexibleMaximumDuration;
  }

  public TimePoint getExpectedDuration()
  {
    return expectedDuration;
  }

  public ActivityDurationUpdateProcedureData getActivityDurationUpdateProcedure()
  {
    return null;
  }

  public PluginData getTemporalExceptionHandlingProcedure()
  {
    return null;
  }

  public PluginData getEscalationData()
  {
    return null;
  }

  public void setFlexibleMinimumDuration(TimePoint duration)
  {
    flexibleMinimumDuration = duration;
  }
  
  public void setGuardMinimumDuration(TimePoint duration)
  {
    guardMinimumDuration = duration;
  }

  public void setGuardMaximumDuration(TimePoint duration)
  {
    guardMaximumDuration = duration;
  }

  public void setFlexibleMaximumDuration(TimePoint duration)
  {
    flexibleMaximumDuration = duration;
  }

  public void setExpectedDuration(TimePoint duration)
  {
    expectedDuration = duration;
  }

  public void setActivityDurationUpdateProcedure(ActivityDurationUpdateProcedureData data)
  {
    //
  }

  public void setTemporalExceptionHandlingProcedure(PluginData data)
  {
    //
  }

  public void setEscalationData(PluginData data)
  {
    //
  }

  public TimePoint getContingency()
  {
    return contingency;
  }

  public void setContingency(TimePoint contingency)
  {
    this.contingency = contingency;
  }



}
