package de.aristaflow.adept2.model.processmodel.timemodel.schedules.evaluation;

import java.util.Calendar;

import de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.expression.CalendarExpression;

public class CalendarCache
{

  private final CalendarExpression calendarExpression;
  
  private IntervalSet cache;

  public CalendarCache(CalendarExpression calendarExpression)
  {
    this.calendarExpression = calendarExpression;
  }

  public IntervalSet evaluate(Evaluator evaluator, Calendar from, Calendar until, boolean inclusive)
  {
//    if (cache == null)
//    {
      cache = evaluator.evaluteNoCache(calendarExpression, from, until, inclusive);
//    }
//    else
//    {
//      Calendar start = cache.getStart();
//      Calendar end = cache.getEnd();
//      if (start.compareTo(from) <= 0 && end.compareTo(until) >= 0)
//      {
//        return cache.range(from, until);
//      }
//      else
//      {
//        if (cache instanceof ContinuousIntervalSet)
//        {
//          cache = evaluator.evaluteNoCache(calendarExpression, min(from, start), max(until, end), inclusive);
//        }
//        else
//        {
//          if (min(start, from) != start)
//          {
//            cache = evaluator.evaluteNoCache(calendarExpression, min(from, start), max(until, end), inclusive);
//          }
//          else
//          {
//            IntervalSet evaluteNoCache = evaluator.evaluteNoCache(calendarExpression, end, until, inclusive);
//            addAll((ComplexIntervalSet)cache, evaluteNoCache);
//            return cache.range(from, until);
//          }
//          
//          throw new IllegalStateException();
//        }
//      }
//    }
    return cache;
  }

  private void addAll(ComplexIntervalSet cache, IntervalSet newItems)
  {
    for (TimeFrame tf : newItems.getTimeFrames())
    {
      if (tf.getStart().compareTo(cache.getEnd()) >= 0)
        cache.add(tf);
    }
  }

  private Calendar max(Calendar c1, Calendar c2)
  {
    return c1.compareTo(c2) > 0 ? c1 : c2;
  }

  private Calendar min(Calendar c1, Calendar c2)
  {
    return c1.compareTo(c2) > 0 ? c2 : c1;
  }

}
