package de.aristaflow.adept2.model.processmodel.timemodel.schedules.evaluation;

import java.text.SimpleDateFormat;
import java.util.Calendar;

import de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.expression.BasicCalendar;

public class Interval implements TimeFrame
{
  SimpleDateFormat format = new SimpleDateFormat("dd.MM.yy HH:mm:ss.S");
  
  private final BasicCalendar granule;
  
  private final Calendar from;
  private final Calendar to;

  

  public Interval(BasicCalendar granule, Calendar from, Calendar to)
  {
    this.granule = granule;
    this.from = from;
    this.to = to;
    
  }

  @Override
  public Calendar getStart()
  {
    return from;
  }

  @Override
  public Calendar getEnd()
  {
    return to;
  }
  
  @Override
  public String toString()
  {
    return format.format(from.getTime()) + "--" + format.format(to.getTime());
  }

  public BasicCalendar getGranule()
  {
    return granule;
  }
}
