package de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.expression;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;


public enum BasicCalendar
{
  SECONDS(Calendar.SECOND, new SimpleDateFormat("dd.MM.yy hh:mm:ss")), 
  MINUTES(Calendar.MINUTE, new SimpleDateFormat("dd.MM.yy hh:mm")), 
  HOURS(Calendar.HOUR_OF_DAY, new SimpleDateFormat("dd.MM.yy hh")), 
  DAYS(Calendar.DAY_OF_YEAR, new SimpleDateFormat("dd.MM.yy")), 
  WEEKS(Calendar.WEEK_OF_YEAR, new SimpleDateFormat("ww-yyyy")), 
  MONTHS(Calendar.MONTH, new SimpleDateFormat("MMM yyyy")), 
  YEARS(Calendar.YEAR, new SimpleDateFormat("yyyy"));

  private final int calendarConst;

  public final DateFormat format;
  
  private BasicCalendar(int calendarConst, DateFormat format)
  {
    this.calendarConst = calendarConst;
    this.format = format;
  }

  public int getCalendarConstant()
  {
    return calendarConst;
  }
  
  public String format(Calendar calendar)
  {
    return format.format(calendar.getTime());
  }
}
