package de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.expression;


public class Dicing implements CalendarExpression
{
  private Setops setop;
  private boolean strict;
  

  
  private CalendarExpression firstOperand;


  private CalendarExpression secondOperand;

  public Dicing()
  {
  }
  
  /**
   * @return the setop
   */
  public Setops getSetOperator() {
    return setop;
  }
  /**
   * @param setop the setop to set
   */
  public void setSetop(Setops setop) {
    this.setop = setop;
  }
  /**
   * @return the strict
   */
  public boolean isStrict() {
    return strict;
  }
  /**
   * @param strict the strict to set
   */
  public void setStrict(boolean strict) {
    this.strict = strict;
  }


  /**
   * @return the ident
   */
  public CalendarExpression getFirstOperand()
  {
    return firstOperand;
  }

  /**
   * @param ident the ident to set
   */
  public void setFirstOperand(CalendarExpression ident)
  {
    this.firstOperand = ident;
    
    validateInput();
  }



  private void validateInput()
  {
    if (firstOperand != null && secondOperand != null)
    {
      BasicCalendar granule1 = this.firstOperand.getGranule();
      BasicCalendar granule2 = this.secondOperand.getGranule();
      
      if (granule1 != null && granule2 != null)
      {
        if (granule1.ordinal() >= granule2.ordinal())
        {
          throw new IllegalArgumentException("Incomplatible dicing: "+this.toString());
        }
      }
        
    }
  }

  /**
   * @return the calendarExpression
   */
  public CalendarExpression getSecondOperand()
  {
    return secondOperand;
  }

  /**
   * @param calendarExpression the calendarExpression to set
   */
  public void setSecondOperand(CalendarExpression calendarExpression)
  {
    this.secondOperand = calendarExpression;
    
    validateInput();
  }
  
  public BasicCalendar getGranule()
  {
    return this.firstOperand != null ? this.firstOperand.getGranule() : null;
  }

  @Override
  public String toString()
  {
    StringBuilder stringBuilder = new StringBuilder();
    
    stringBuilder.append(firstOperand);
    if (strict)
      stringBuilder.append(":"+setop+":");
    else
      stringBuilder.append("."+setop+"."); 
//    stringBuilder.append(dicing);
    stringBuilder.append(secondOperand);

    return stringBuilder.toString();
  }

}
