package de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.expression;

import de.aristaflow.adept2.util.NullArgumentException;

/**
 * Beschreibt eine Variable von type CalendarExpression attribute id enthältder
 * Name der Variable und pointer zeigt auf der zugeordnete CalenderExpression
 * 
 * @author Abdel Guerroudj
 */

public class Ident implements CalendarExpression
{
  public String id;

//  public CalendarExpression pointer;
  
  public Ident(String id)
  {
    this.id = id;
    if (id == null)
      throw new NullArgumentException();
  }

  /**
   * @return the id
   */
  public String getId()
  {
    return id;
  }

  
  @Override
  public String toString()
  {
    return "[id:"+id+"]";
  }

  @Override
  public int hashCode()
  {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((id == null) ? 0 : id.hashCode());
    return result;
  }

  @Override
  public boolean equals(Object obj)
  {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    Ident other = (Ident) obj;
    if (id == null)
    {
      if (other.id != null)
        return false;
    }
    else if (!id.equals(other.id))
      return false;
    return true;
  }

  @Override
  public BasicCalendar getGranule()
  {
    return null;
  }
  
  
}
