package de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.expression;

import java.util.LinkedList;
import java.util.List;

/**
 * implementiert eine Liste von SimpleSlicing Elemente
 * 
 * @author Abdel Guerroudj
 */

public class SetSelection implements Slicing
{
  private List<Integer> setSelection;
  private CalendarExpression calendarExpression;


  
  public SetSelection()
  {
    setSelection = new LinkedList<Integer>();
  }
  
  public void setCalendarExpression(CalendarExpression calendarExpression)
  {
    this.calendarExpression = calendarExpression;
  }
  
  public CalendarExpression getCalendarExpression()
  {
    return this.calendarExpression;
  }
  
  public String toString()
  {
    StringBuilder stringBuilder = new StringBuilder();
    stringBuilder.append("[");
    String sep = "";
    for (Integer sl : setSelection)
    {
      stringBuilder.append(sep);
      sep = ", ";
      stringBuilder.append(sl);
    }
    stringBuilder.append("]");
    stringBuilder.append("/");
    stringBuilder.append(this.calendarExpression);
    return stringBuilder.toString();
  }

  public void addSelection(Integer ssl)
  {
    this.setSelection.add(ssl);
    
  }

  public List<Integer> getSetSelection()
  {
    return setSelection;
  }
  
  public BasicCalendar getGranule()
  {
    return this.calendarExpression != null ? this.calendarExpression.getGranule() : null;
  }

}
