package de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.expression;

public class Union implements CalendarExpression
{

  private final CalendarExpression first;
  private final CalendarExpression second;

  public Union(CalendarExpression first, CalendarExpression second)
  {
    this.first = first;
    this.second = second;
    
    if (first.getGranule() != null && second.getGranule() != null)
    {
      if (!first.getGranule().equals(second.getGranule()))
        throw new IllegalArgumentException("Granules must be the same: "+first.getGranule()+" vs. "+second.getGranule());
    }
  }
  
  @Override
  public BasicCalendar getGranule()
  {
    return this.first.getGranule() != null ? this.first.getGranule() : this.second.getGranule();
  }
  
  public String toString()
  {
    return getFirst() + " + "  + getSecond();
  }

  public CalendarExpression getSecond()
  {
    return second;
  }

  public CalendarExpression getFirst()
  {
    return first;
  }

}
