package de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.script;

import de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.expression.CalendarExpression;

/**
 * Beschreibt ein If Statement mit Condition- und Body-teil
 * 
 * @author Abdel Guerroudj
 */

public class IfStmt implements CalendarStatement
{
  private CalendarExpression condition;

  private CalendarScript trueScript;

  private CalendarScript falseScript;

  public IfStmt()
  {
    trueScript = new CalendarScript();
    falseScript = new CalendarScript();
  }

  /**
   * @return the condition
   */
  public CalendarExpression getCondition()
  {
    return condition;
  }

  /**
   * @param condition the condition to set
   */
  public void setCondition(CalendarExpression condition)
  {
    this.condition = condition;
  }

  /**
   * @return the calendarScript
   */
  public CalendarScript getTrueScript()
  {
    return trueScript;
  }
  
  public CalendarScript getFalseScript()
  {
    return falseScript;
  }

//  /**
//   * @param calendarScript the calendarScript to set
//   */
//  public void setCalendarScript(CalendarScript calendarScript)
//  {
//    this.calendarScript = calendarScript;
//  }


  @Override
  public boolean isStmtEmpty()
  {
    return (condition == null);
  }

  @Override
  public String toString()
  {
    return "if ("+condition+") {"+trueScript+"} else {"+falseScript+"}";
  }
  
}
