package de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.script;
import de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.expression.CalendarExpression;

/**
 *enthält ein Stack um Operanden (Calendarexpressions) und Opratoren (+ oder -)
 *einen CalendarExpression zu speichern 
 *@author Abdel Guerroudj
 */

public class ReturnExpression implements ReturnStmt {
	private final CalendarExpression  calendarExpression; 
	public ReturnExpression(CalendarExpression calendarExpression) {
    
    if (calendarExpression == null)
      throw new IllegalArgumentException("null");
    
	  this.calendarExpression = calendarExpression;


	}
    

	public String toString()
	{
	  return "return("+calendarExpression.toString()+")";
	}


  public CalendarExpression getCalendarExpression()
  {
    return calendarExpression;
  }


  @Override
  public boolean isStmtEmpty()
  {
    return false;
  }
	
}
