package de.aristaflow.adept2.model.processmodel.timemodel.updatehandlers;

import java.net.URI;

import de.aristaflow.adept2.base.sessionmanagement.SessionToken;
import de.aristaflow.adept2.model.common.PluginData;
import de.aristaflow.adept2.model.common.timedata.CalendarElement;
import de.aristaflow.adept2.model.common.timedata.TimePoint;
import de.aristaflow.adept2.model.common.timedata.defaultimplementation.DefaultCalendarElement;
import de.aristaflow.adept2.model.common.viewer.ModelViewer;
import de.aristaflow.adept2.model.processmodel.Node;
import de.aristaflow.adept2.model.processmodel.Template;
import de.aristaflow.adept2.model.processmodel.timemodel.FixedDateUpdateHandler;
import de.aristaflow.adept2.model.processmodel.timemodel.FixedDateUpdateMeasures;
import de.aristaflow.adept2.model.processmodel.timemodel.FixedDateUpdateProcedureData;
import de.aristaflow.adept2.model.timemodel.TimeModelOperations;
import de.aristaflow.adept2.model.timemodel.defaultimplementation.DefaultTimeModelOperations;

//FIXME AL: Implement
public class DataElementFixedDateUpdateHandler implements
    FixedDateUpdateHandler
{

  public static final String ID = "de.aristaflow.adept2.model.processmodel.timemodel.updatehandlers.DataElementFixedDateUpdateHandler";

  
  TimeModelOperations operations = new DefaultTimeModelOperations(); // FIXME

  public String getID()
  {
    return ID;
  }

  public PluginData[] getUpdateTriggerList(Template template, Node node, FixedDateUpdateProcedureData configuration)
  {
    // TODO Auto-generated method stub
    return new PluginData[0];
  }


  @Override
  public void updateFixedDate(SessionToken session, int targetNodeID, int nodeIteration,
      URI trigger, FixedDateUpdateProcedureData configuration, FixedDateUpdateMeasures updateMeasures)
  {
    DataElementFixedDateConfiguration config = ModelViewer.createView(configuration.getConfiguration().getPluginData(),
                                                                      DataElementFixedDateConfiguration.class);

    String earliestDateParameter = config.getEarliestDateParameterName();
    if (earliestDateParameter != null)
    {
      String value = updateMeasures.resolveParameterString(session, targetNodeID, earliestDateParameter);
  
      long dateValue = Long.parseLong(value);
      CalendarElement date = new DefaultCalendarElement(dateValue);
      
      updateMeasures.updateEarliestDate(session, targetNodeID, nodeIteration, date, true);
      
      TimePoint relativeDate = config.getLatestRelativeDate();
      if (relativeDate != null)
      {
        CalendarElement date2 = operations.add(date, relativeDate);
        updateMeasures.updateLatestDate(session, targetNodeID, nodeIteration, date2, true);
      }
    }
    else
    {
      String latestDateParameter = config.getLatestDateParameterName();
      if (latestDateParameter != null)
      {
        String value = updateMeasures.resolveParameterString(session, targetNodeID, latestDateParameter);
        
        long dateValue = Long.parseLong(value);
        CalendarElement date = new DefaultCalendarElement(dateValue);
        
        updateMeasures.updateLatestDate(session, targetNodeID, nodeIteration, date, true);
        
        TimePoint relativeDate = config.getEarliestRelativeDate();
        if (relativeDate != null)
        {
          CalendarElement date2 = operations.add(date, relativeDate);
          updateMeasures.updateEarliestDate(session, targetNodeID, nodeIteration, date2, true);
        }
      }
    }
      
    
    
  }

}
