package de.aristaflow.adept2.model.timemodel;

import java.net.URI;
import java.util.List;
import java.util.UUID;

import de.aristaflow.adept2.model.common.timedata.CalendarElement;
import de.aristaflow.adept2.model.common.timedata.TimeDistance;
import de.aristaflow.adept2.model.globals.TimeModelConstants.RelationType;

public interface InstanceTimeModel extends TimeModel//, Instance
{
  int PROCESS_INSTANTIATION_EVENT = 0;
  
  public UUID getInstanceID();
  
  public UUID getBaseTemplateID();

  public Interval<CalendarElement> getInstanceStartTimeframe();
  
  public Interval<CalendarElement> getInstanceCompletionTimeframe();
  
  public Interval<TimeDistance> getInstanceDuration();
  
  public Interval<TimeDistance> getActivityInstanceDuration(int nodeID, int iteration);
  
  public Interval<CalendarElement> getActivityInstanceStartTimeframe(int nodeID, int iteration);
  
  public Interval<CalendarElement> getActivityInstanceCompletionTimeframe(int nodeID, int iteration);
  
  public Interval<TimeDistance> getTimeLag(int fromNodeID, int fromIteration,
                                        int toNodeID, int toIteration, RelationType relationType);

  List<URI> getUpdateTrigger(int nodeID);
}
