package de.aristaflow.adept2.model.timemodel;

import java.util.UUID;

import de.aristaflow.adept2.model.common.timedata.TimeDistance;
import de.aristaflow.adept2.model.common.timedata.TimePoint;
import de.aristaflow.adept2.model.globals.TimeModelConstants.RelationType;
import de.aristaflow.adept2.model.processmodel.Template;

public interface TemplateTimeModel extends TimeModel//, Template
{
  public UUID getTemplateID();
  
  public Template getBaseTemplate();
  
  
  public Interval<TimeDistance> getProcessDuration();
  
  public Interval<TimePoint> getProcessStartTimeframe();
  
  public Interval<TimePoint> getProcessCompletionTimeframe();
  
  

  
  
  public Interval<TimeDistance> getActivityDuration(int nodeID);
  
  
  /**
   * LOW-AL: How to handle loops?
   * @param nodeID the id of the node
   * @return The starting time frame of the node after considering validity periods etc.
   */
  public Interval<TimePoint> getActivityStartTimeframe(int nodeID);
  
  /**
   * LOW-AL: How to handle loops?
   * @param nodeID the id of the node
   * @return The completion time frame of the node after considering validity periods etc.
   */
  public Interval<TimePoint> getActivityCompletionTimeframe(int nodeID);
  
  
  public Interval<TimeDistance> getTimeLag(int fromNodeID,
                                        int toNodeID, RelationType relationType);
  
  

}
