package de.aristaflow.adept2.model.timemodel;

import de.aristaflow.adept2.model.processmodel.Instance;
import de.aristaflow.adept2.model.processmodel.Template;
import de.aristaflow.adept2.model.processmodel.TemporalTemplate;

public interface TimeModelFactory {
  /* {src_lang=Java}*/
  
  public TemplateTimeModel createTimeModelForTemplate(TemporalTemplate template);

  public InstanceTimeModel createTimeModelForInstance(Instance instance, InstanceTimeContext timeContext, TemplateTimeModel templateTimeModel);
  
  public TimeModelOperations getTimeModelOperations();

  public void setCreateChangeable(boolean changeable);

  public TemporalTemplate createTemporalTemplate(Template template);

  TimeModelSolver getTimeModelSolver(Class<? extends TimeModel> timeModelClass);

//  public InstanceTimeModel createTimeModelForInstance(
//      InstanceTimeModel timeModel);
}