package de.aristaflow.adept2.model.timemodel;

import de.aristaflow.adept2.model.common.timedata.CalendarElement;
import de.aristaflow.adept2.model.common.timedata.TimeDistance;
import de.aristaflow.adept2.model.common.timedata.TimePoint;


public interface TimeModelOperations {
  /* {src_lang=Java}*/

  public int compare(CalendarElement date, long timestamp);
  
  public int compare(TimePoint timePoint1, TimePoint timePoint2);

  public CalendarElement add(long timeStamp, TimePoint duration);

  public int compare(CalendarElement date1,
      CalendarElement date2);

  public CalendarElement convertToCalendarElement(TimeDistance maxValue);

  public TimePoint convertToTimePoint(TimeDistance value);

  public TimeDistance secondsToTimeDistance(long seconds);
  public TimeDistance millisecondsToTimeDistance(long milliseconds);

  long convertToSeconds(TimePoint timePoint);

  public TimeDistance convertToTimeDistance(
      TimePoint timePoint);

  public CalendarElement add(long timeStamp, TimeDistance duration);
  
  public CalendarElement add(CalendarElement timeStamp, TimePoint duration);

  public GuardedInterval<TimeDistance> getRestrictableProcessDuration(TimeModel timeModel);

}