package de.aristaflow.adept2.model.timemodel;

public interface TimeModelSolver
{
  /* {src_lang=Java} */

  /**
   * 
   * @param timeModel
   * @throws InconsistencyException
   * @throws InterruptedException Not this may be a very long running operation,
   *           so interruption is supported (using {@link Thread#interrupt()}).
   *           In this case a {@link InterruptedException} will be thrown.
   *           <b>Note</b> that in this case the state of the input
   *           {@link TimeModel} may be undefined.
   * 
   */
  void solve(TimeModel timeModel) throws InconsistencyException, InterruptedException;

}