package de.aristaflow.adept2.model.timemodel;

import java.util.List;

import de.aristaflow.adept2.base.sessionmanagement.SessionToken;
import de.aristaflow.adept2.model.common.timedata.CalendarElement;
import de.aristaflow.adept2.model.processmodel.Node;


public interface UpdateableInstanceTimeModel extends InstanceTimeModel
{
  
  void setInstanceCreationTime(long timestamp);

  void setInstanceStartTime(long timestamp);

  void setInstanceFinishTime(long timestamp);

  void setNodeActivationTime(int nodeID, int iteration, long timestamp);

  void setActivityInstanceStartTime(int nodeID, int iteration, long timestamp);

  void setActivityInstanceFinishTime(int nodeID, int iteration, long timestamp);

  void setActivityInstanceProgress(int nodeID, int iteration, float progress);
  
  void createNewIteration(List<Node> nodesInLoop, int iteration);

  void setEarliestStartDate(SessionToken session, int nodeID, int iteration, CalendarElement date);

  void setEarliestCompletionDate(SessionToken session, int nodeID, int iteration, CalendarElement date);

  void setLatestStartDate(SessionToken session, int nodeID, int iteration, CalendarElement date);

  void setLatestCompletionDate(SessionToken session, int nodeID, int iteration, CalendarElement date);

}
