package de.aristaflow.adept2.model.timemodel.defaultimplementation;

import de.aristaflow.adept2.model.timemodel.ChangeSet.ChangeEntry;

public final class DefaultChangeEntry<E, T, R> implements ChangeEntry<E, T, R>
{
  
  private final E element;
  private final T oldValue;
  private final T newValue;
  private final R causedBy;
  private final String reason;
  
  public DefaultChangeEntry(E element, T oldValue, T newValue, R causedBy, String reason)
  {
    this.element = element;
    this.oldValue = oldValue;
    this.newValue = newValue;
    this.causedBy = causedBy;
    this.reason = reason;
  }

  @Override
  public boolean equals(Object obj)
  {
    return element.equals(obj);
  }

  @Override
  public int hashCode()
  {
    return element.hashCode();
  }

  @Override
  public E getElement()
  {
    return this.element;
  }
  
  @Override
  public String toString()
  {
    return "{Caused By: "+this.causedBy + " ("+this.getReason()+") ==> Element: " + this.element + ":  from " + this.getOldValue() +" to " + this.getNewValue() + "}"; 
  }

  public R getCausedBy()
  {
    return causedBy;
  }

  public T getOldValue()
  {
    return oldValue;
  }

  public T getNewValue()
  {
    return newValue;
  }

  public String getReason()
  {
    return reason;
  }
  
  
}