package de.aristaflow.adept2.model.timemodel.defaultimplementation;


import java.sql.DriverManager;
import java.util.Iterator;
import java.util.LinkedHashMap;

import de.aristaflow.adept2.model.timemodel.ChangeSet;



public class DefaultChangeSet<E, T, R> implements ChangeSet<E,T, R>
{

  LinkedHashMap<E, ChangeEntry<E, T, R>> log = new LinkedHashMap<E, ChangeEntry<E,T,R>>();
  //List<ChangeEntry<E, T, R>> log = new ArrayList<ChangeEntry<E, T, R>>();
  
  @Override
  public void logChange(E element, T oldValue, T newValue, R causedBy, String reason)
  {
    log.remove(element);
    log.put(element, new DefaultChangeEntry<E, T, R>(element, oldValue, newValue, causedBy, reason));
  }
  
  public void logChange(E element, T oldValue, T newValue, R causedBy)
  {
    logChange(element, oldValue, newValue, causedBy, null);
  }
  
  @Override
  public String toString()
  {
    StringBuilder s = new StringBuilder();
    
    for (ChangeEntry<E, T, R> e : log.values())
    {
      s.append(e);
      s.append('\n');
    }
    
    return s.toString();
  }

  @Override
  public boolean hasChange(E element)
  {
    for (ChangeEntry<E, T, R> elem : log.values())
    {
      if (elem.getElement().equals(element))
        return true;
    }
    return false;
  }
  
  public Iterator<ChangeEntry<E, T, R>> iterator()
  {
    Iterator<ChangeEntry<E, T, R>> iterator = log.values().iterator();
    return iterator;
  }

//  public Iterator<ChangeEntry<E, T, R>> getHistory()
//  {
//    return new Iterator<ChangeEntry<E, T, R>>()
//    {
//      
//      int index = log.size();
//      
//      @Override
//      public boolean hasNext()
//      {
//        return index > 0;
//      }
//
//      @Override
//      public ChangeEntry<E, T, R> next()
//      {
//        if (hasNext())
//        {
//          return log.get(--index);
//        }
//        else
//        {
//          throw new NoSuchElementException();
//        }
//      }
//
//      @Override
//      public void remove()
//      {
//        // Not supported
//      }
//    };
//    
//  }
  
}