package de.aristaflow.adept2.model.timemodel.defaultimplementation;

import de.aristaflow.adept2.model.timemodel.GuardedInterval;

public class DefaultGuardedInterval<E>  extends DefaultInterval<E> implements GuardedInterval<E>
{

  private E guardMaxValue;
  private E guardMinValue;
  private E contingency;

  public DefaultGuardedInterval(E flexibleMinValue, E guardMinValue, E guardMaxValue, E flexibleMaxValue, E contingency)
  {
    super(flexibleMinValue, flexibleMaxValue);
    this.guardMinValue = guardMinValue;
    this.guardMaxValue = guardMaxValue;
    this.contingency = contingency;
  }
  
  public E getFlexibleMinimum()
  {
    return getMinValue();
    
  }

  public E getGuardedMinimum()
  {
    return this.guardMinValue;
  }

  public E getGuardedMaximum()
  {
    return guardMaxValue;
  }

  public E getFlexibleMaximum()
  {
    return getMaxValue();
  }

  @Override
  public String toString()
  {
    StringBuilder stringBuilder = new StringBuilder();
    stringBuilder.append("[");
    stringBuilder.append(getFlexibleMinimum());
    stringBuilder.append(", ");
    stringBuilder.append(getGuardedMinimum());
    stringBuilder.append("][");
    stringBuilder.append(getGuardedMaximum());
    stringBuilder.append(", ");
    stringBuilder.append(getFlexibleMaximum());
    stringBuilder.append("]");
    stringBuilder.append("@");
    stringBuilder.append(getContingency());
    return stringBuilder.toString();
  }

  @Override
  public boolean equals(Object obj)
  {
    if (super.equals(obj))
    {
      if (obj instanceof DefaultGuardedInterval<?>)
      {
        DefaultGuardedInterval<?> other = (DefaultGuardedInterval<?>) obj;
        if (this.guardMaxValue == null)
        {
          if (other.guardMaxValue != null)
            return false;
        }
        else
        {
          if (!this.guardMaxValue.equals(other.guardMaxValue))
            return false;
        }
        
        if (this.guardMinValue == null)
        {
          if (other.guardMinValue != null)
            return false;
        }
        else
        {
          if (!this.guardMinValue.equals(other.guardMinValue))
            return false;
        }
        
        return true;
      }
    }

    return false;
  }

  @Override
  public int hashCode()
  {
    int hashCode = super.hashCode();
    hashCode = hashCode * 31 ^ (this.guardMinValue != null ? this.guardMinValue.hashCode() : 0);
    hashCode = hashCode * 31 ^ (this.guardMaxValue != null ? this.guardMaxValue.hashCode() : 0);
    return hashCode;
  }

  public E getContingency()
  {
    return this.contingency;
  }



  

}
