package de.aristaflow.adept2.model.timemodel.defaultimplementation;

import de.aristaflow.adept2.model.timemodel.Interval;

/**
 * 
 * @author Andreas Lanz
 *
 * @param <T>
 */
public class DefaultInterval<T> implements Interval<T>
{

  private final T minValue;
  private final T maxValue;

  public DefaultInterval(T minValue,
      T maxValue)
  {
    this.minValue = minValue;
    this.maxValue = maxValue;
  }

  public T getMaxValue()
  {
    return maxValue;
  }

  public T getMinValue()
  {
    return minValue;
  }
  
  @Override
  public String toString()
  {
    return "["+minValue+ ", "+maxValue+"]";
  }

  @Override
  public boolean equals(Object obj)
  {
    if (this == obj)
      return true;
    
    if (obj instanceof DefaultInterval)
    {
      DefaultInterval<?> other = (DefaultInterval<?>) obj;
      
      if (this.minValue == null)
      {
        if (other.minValue != null)
          return false;
      }
      else
      {
        if (!this.minValue.equals(other.minValue))
          return false;
      }
      
      if (this.maxValue == null)
      {
        if (other.maxValue != null)
          return false;
      }
      else
      {
        if (!this.maxValue.equals(other.maxValue))
          return false;
      }
      
      return true;
      
    }


    return super.equals(obj);
  }

  @Override
  public int hashCode()
  {
    return (minValue == null ? 0 : minValue.hashCode()) * 31 ^ (maxValue == null ? 0 : maxValue.hashCode());
  }
  


}
