package de.aristaflow.adept2.model.timemodel.defaultimplementation;

import de.aristaflow.adept2.model.globals.TimeModelConstants.BaseGranularity;
import de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.expression.CalendarExpression;
import de.aristaflow.adept2.model.timemodel.Schedule;

public class DefaultSchedule implements Schedule
{

  private final String rule;
  private final BaseGranularity baseGranularity;
  private final CalendarExpression expression;

  public DefaultSchedule(String rule, BaseGranularity granularity, CalendarExpression expression)
  {
    this.rule = rule;
    this.baseGranularity = granularity;
    this.expression = expression; 
  }

  @Override
  public BaseGranularity getBaseGranularity()
  {
    return baseGranularity;
  }

  @Override
  public String getRule()
  {
    return rule;
  }

  public CalendarExpression getExpression()
  {
    return expression;
  }
  
  @Override
  public String toString()
  {
    return expression.toString();
  }

}
