package de.aristaflow.adept2.model.timemodel.defaultimplementation;

import java.util.List;

import de.aristaflow.adept2.model.common.timedata.CalendarElement;
import de.aristaflow.adept2.model.globals.TimeModelConstants.BaseGranularity;
import de.aristaflow.adept2.model.timemodel.Schedule;
import de.aristaflow.adept2.model.timemodel.ScheduleInterval;
import de.aristaflow.adept2.model.timemodel.ScheduleIntervalSet;

public class DefaultScheduleIntervalSet implements ScheduleIntervalSet
{

  private final Schedule schedule;
  private final List<ScheduleInterval> intervals;

  public DefaultScheduleIntervalSet(Schedule schedule, List<ScheduleInterval> intervals)
  {
    this.schedule = schedule;
    this.intervals = intervals;
  }
  
  public Schedule getSchedule()
  {
    return schedule;
  }

  public BaseGranularity getBaseGranularity()
  {
    // TODO Auto-generated method stub
    return null;
  }

  public CalendarElement getFrom()
  {
    return intervals.get(0).getFrom();
  }

  public CalendarElement getTo()
  {
    return intervals.get(intervals.size()-1).getTo();
  }

  public int getSize()
  {
    return intervals.size();
  }

  public ScheduleInterval getInterval(int index)
  {
    return intervals.get(index);
  }

  public ScheduleIntervalSet getSubSet(CalendarElement from, CalendarElement to)
  {
    // TODO Auto-generated method stub
    return null;
  }

  public boolean hasNextInterval(CalendarElement from)
  {
    ScheduleInterval lastInterval = intervals.get(intervals.size() - 1);
    
    return lastInterval.getTo().getTimeInMillis() > from.getTimeInMillis();
  }

  public ScheduleInterval getNextInterval(CalendarElement from)
  {
    for (ScheduleInterval i : this.intervals)
    {
      if (i.getTo().getTimeInMillis() > from.getTimeInMillis())
        return i;
    }
    return null;
  }

  public boolean isFinest()
  {
    // TODO Auto-generated method stub
    return false;
  }

}
