package de.aristaflow.adept2.model.timemodel.defaultimplementation;

import java.util.UUID;

import de.aristaflow.adept2.model.timemodel.ChangeableTimeModelStatus;
import de.aristaflow.adept2.model.timemodel.TimeModelStatus;

/**
 * @author  Andreas Lanz
 */
public class DefaultTimeModelStatus implements TimeModelStatus, ChangeableTimeModelStatus
{

  /**
   * @uml.property  name="updateStatus"
   * @uml.associationEnd  
   */
  private TimeModelUpdateStatus updateStatus;
  private String updateStatusComment;
  /**
   * @uml.property  name="instanceID"
   */
  private final UUID instanceID;
  private TimeModelState status;

  public DefaultTimeModelStatus(UUID instanceID, TimeModelState status, TimeModelUpdateStatus updateStatus)
  {
    this(instanceID, status, updateStatus, null);
  }

  public DefaultTimeModelStatus(UUID instanceID,
      TimeModelState status,
      TimeModelUpdateStatus updateStatus,
      String timeModelUpdateStatusComment)
  {
    this.instanceID = instanceID;
    this.status = status;
    this.updateStatus = updateStatus;
    this.updateStatusComment = timeModelUpdateStatusComment;
  }

  public void setTimeModelUpdateStatus(TimeModelUpdateStatus updateStatus, String comment)
  {
    this.updateStatus = updateStatus;
    this.updateStatusComment = comment;

  }

  public TimeModelUpdateStatus getTimeModelUpdateStatus()
  {
    return updateStatus;
  }

  /**
   * @return
   * @uml.property  name="instanceID"
   */
  public UUID getInstanceID()
  {
    return instanceID;
  }

  public String getTimeModelUpdateStatusComment()
  {
    return updateStatusComment;
  }

  public void setTimeModelStatus(TimeModelState status)
  {
    this.status = status;
  }

  public TimeModelState getTimeModelStatus()
  {
    return this.status;
  }

}
