package de.aristaflow.adept2.model.timemodel.defaultimplementation;

import de.aristaflow.adept2.util.Tuple;

public class Path<N> extends Tuple<N, N>
{

  private int cachedhashCode;

  public Path(N first, N second)
  {
    super(first, second);
    
    int PRIME = 211;
    
    cachedhashCode = 1;
    cachedhashCode = cachedhashCode ^ (getFirst() != null ? getFirst().hashCode() : 0);
    cachedhashCode = PRIME * cachedhashCode ^ (getSecond() != null ? getSecond().hashCode() : 0);
  }
  
  public N getFrom()
  {
    return getFirst();
  }
  
  public N getTo()
  {
    return getSecond();
  }
  
  @Override
  public int hashCode()
  {
    return cachedhashCode;
  }



  @Override
  public boolean equals(Object obj)
  {
    if (obj == this)
      return true;
    if (obj == null || !(obj instanceof Path<?>))
    {
      return false;
    }
    Path<?> f = (Path<?>) obj;

    return (getFirst() == f.getFirst())
           && (getSecond() == f.getSecond());
  }

}
