package de.aristaflow.adept2.model.timemodel.tcn;

public interface LabelSet
{

  /**
   * 
   * @return the labels of all values contained within this set
   */
  Label[] getLabels();



  /**
   * Checks whether <code>this</code> in combination with <code>label</code> is
   * satisfiable. A label set is satisfiable in combination with another label
   * if each of the labels contained within the set is satisfiable in
   * combination with the respective label.
   * 
   * @param label the label to check
   * @return <code>true</code> in case <code>this</code> in combination with
   *         <code>label</code> is satisfiable, <code>false</code> otherwise.
   */
  boolean satisfiable(Label label);
  
  /**
   * Checks whether <code>this</code> subsumes <code>label</code> (see
   * {@link Label#subsumes(Label)}). A label set subsumes an other label if each
   * of the labels contained within the set subsumes the respective label.
   * 
   * @param label the label possibly subsumed by this
   * @return <code>true</code> in case <code>this</code> subsumes
   *         <code>label</code>, <code>false</code> otherwise.
   */
  boolean subsumes(Label label);

}
