package de.aristaflow.adept2.model.timemodel.tcn;

import de.aristaflow.adept2.model.common.timedata.TimeDistance;

public interface LabeledValue extends SimpleConstraintValue
{
  Label getLabel();
  
  TimeDistance getValue();
  
  /**
   * 
   * see Conrad et al. (2011) <br/>
   * <pre>
   * Definition 4.7 (Dominated Labeled Value Pair) Let (a; e_a); (b; e_b) be two
   * labeled value pairs where the values are ordered with <=. Then (a; e_a)
   * dominates (b; e_b) if a <= b and e_a subsumes e_b.
   * </pre>
   * 
   * @param other
   * @return <code>true</code> if <code>this</code> dominates <code>other</code>
   *         , <code>false</code> otherwise
   */
  boolean dominates(LabeledValue other);
  
}