package de.aristaflow.adept2.model.timemodel.tcn;

import java.util.Collection;


public interface LabeledValueSet extends CompoundConstraintValue, LabelSet
{

  //public LabelSet getLabels();

  public Collection<LabeledValue> getLabeledValues();

  /**
   * Merges two {@link LabeledValueSet} into one. Note that the result may not
   * necessarily contain the {@link LabeledValue}s of both
   * {@link LabeledValueSet}s, but may contain only a subset thereof, i.e., it
   * is possible a {@link LabeledValue} is rendered redundant by some other
   * {@link LabeledValue}.
   * 
   * @param other the {@link LabeledValueSet} to be merged with
   *          <code>this</code>
   * @return a new {@link LabeledValueSet} representing the "Union" of
   *         <code>this</code> and <code>other</code>
   */
  LabeledValueSet merge(LabeledValueSet other);

  LabeledValueSet addOrReplaceIfNecessary(LabeledValue newLabel);
  
}
