package de.aristaflow.adept2.model.timemodel.tcn;

import de.aristaflow.adept2.model.timemodel.InconsistencyException;
import de.aristaflow.adept2.model.timemodel.defaultimplementation.Path;

/**
 * @author lanz
 */
public class TCNInconsistencyException extends InconsistencyException
{

  /**
   * 
   */
  private static final long serialVersionUID = 1188294279868009378L;

  
   /**
   * @uml.property name="startEvent"
   * @uml.associationEnd
   */
  private TCNTimePoint startEvent;

  
   /**
   * @uml.property name="endEvent"
   * @uml.associationEnd
   */
  private TCNTimePoint endEvent;


  private TCNTimePoint intermediateEvent;

//  public <N extends TCNTimePoint, E extends TCNEdge<N, ?>> TCNInconsistencyException(
//    String message, N i, N j, TCN<N, E> model)
//  {
//    this(message, i, j, null, model, null);
//  }
  
  public <N extends TCNTimePoint, E extends TCNEdge<N, ?>> TCNInconsistencyException(
      String message, Path<N> p, N k, TCN<N, E> model)
  {
    this(message, p, k, model, null);
  }

  public <N extends TCNTimePoint, E extends TCNEdge<N, ?>> TCNInconsistencyException(
      String message, Path<N> p, N k, TCN<N, E> model, Throwable cause)
  {
    super(message, cause, model);
    // super(message + " Between elements " + getKind(i) + "(" + i + ") and "
    // + getKind(j) + "(" + j + ") with model : \n\n" /* + model */+ "\n\n");
    this.startEvent = p.getFrom();
    this.endEvent = p.getTo();
    this.intermediateEvent = k;
  }

//  public TCNInconsistencyException(String message)
//  {
//    super(message);
//  }


  
  public <N extends TCNTimePoint, E extends TCNEdge<N, ?>> TCNInconsistencyException(String message, TCN<N, E> model)
  {
    super(message, model);
  }

  /**
   * @return
   * @uml.property name="startEvent"
   */
  public TCNTimePoint getStartEvent()
  {
    return startEvent;
  }

  /**
   * @return
   * @uml.property name="endEvent"
   */
  public TCNTimePoint getEndEvent()
  {
    return endEvent;
  }
  

  /**
   * @return
   * @uml.property name="intermediateEvent"
   */
  public TCNTimePoint getIntermediateEvent()
  {
    return intermediateEvent;
  }

}
