package de.aristaflow.adept2.model.timemodel.tcn;

import de.aristaflow.adept2.model.timemodel.ChangeSet;
import de.aristaflow.adept2.model.timemodel.TimeModel;
import de.aristaflow.adept2.model.timemodel.defaultimplementation.Triangle;
import de.aristaflow.adept2.util.types.Triple;

public interface TCNSolver<N extends TCNTimePoint, V extends ConstraintValue, E extends TCNEdge<N, V>>
{
  
  /**
   * 
   * @param tcn <b>May or may not be modified by this operation (depending on the implementation)</b>
   * @return
   * @throws TCNInconsistencyException
   * @throws InterruptedException
   * @throws InterruptedException Not this may be a very long running operation,
   *           so interruption is supported (using {@link Thread#interrupt()}).
   *           In this case a {@link InterruptedException} will be thrown.
   *           <b>Note</b> that in this case the state of the input
   *           {@link TimeModel} may be undefined.
   * 
   */
  public <T extends ChangeableTCN<N, E>> T solve(T tcn) throws TCNInconsistencyException, InterruptedException;
  
  /**
   * 
   * @param tcn <b>May or may not be modified by this operation (depending on the implementation)</b>
   * @param changeSet
   * @return
   * @throws TCNInconsistencyException
   * @throws InterruptedException Not this may be a very long running operation,
   *           so interruption is supported (using {@link Thread#interrupt()}).
   *           In this case a {@link InterruptedException} will be thrown.
   *           <b>Note</b> that in this case the state of the input
   *           {@link TimeModel} may be undefined.
   * 
   */
  public <T extends ChangeableTCN<N, E>> T solve(T tcn,
      ChangeSet<E, V, Triangle<N>> changeSet) throws TCNInconsistencyException, InterruptedException;

}
