package de.aristaflow.adept2.model.timemodel.tcn.cstnImpl;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import de.aristaflow.adept2.model.timemodel.tcn.ChangeableCSTN;
import de.aristaflow.adept2.model.timemodel.tcn.Label.ChoiceVariable;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.AbstractChangeableProjection;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledEdge;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;

public abstract class AbstractCSTNProjection extends
    AbstractChangeableProjection<LabeledTimePoint, LabeledEdge, LabeledEdge> implements ChangeableCSTN
{

  
  public AbstractCSTNProjection(ChangeableCSTN cstn, boolean propagate)
  {
    super(cstn, propagate);
  }
  

  @Override
  public ChangeableCSTN getBaseTCN()
  {
    return (ChangeableCSTN) super.getBaseTCN();
  }
  
  @Override
  protected LabeledEdge propagateUpdate(LabeledEdge edge)
  {
    return getBaseTCN().updateConstraint(edge);
  }
  
  @Override
  public ChangeableCSTN clone()
  {
    // Nodes are immutable
    Collection<LabeledTimePoint> nodes = new ArrayList<LabeledTimePoint>(getTimePoints());
    Collection<LabeledEdge> edges = new ArrayList<LabeledEdge>();
    
    for (LabeledTimePoint n1 : nodes)
    {
      for (LabeledTimePoint n2 : nodes)
      {
        LabeledEdge edge = getEdge(n1, n2);
        if (edge != null)
          edges.add(edge.clone());
      }
    }
    
    // NodeMappings are immutable
    
    return new DefaultCSTN(nodes, edges, getBaseTCN().getObservations());
  }
  
  @Override
  public List<ChoiceVariable> getObservations()
  {
    return getBaseTCN().getObservations();
  }

}