package de.aristaflow.adept2.model.timemodel.tcn.cstnImpl;

import java.net.URI;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import de.aristaflow.adept2.model.common.timedata.TimeDistance;
import de.aristaflow.adept2.model.common.timedata.defaultimplementation.DefaultTimeDistance;
import de.aristaflow.adept2.model.processmodel.Template;
import de.aristaflow.adept2.model.timemodel.TemplateTimeModel;
import de.aristaflow.adept2.model.timemodel.tcn.CSTN;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;
import de.aristaflow.adept2.model.timemodel.tcn.NodeMapping;
import de.aristaflow.adept2.model.timemodel.tcn.TCNTemplateTimeModel;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.STNEdge;

/**
 * NOTE that the CSTNU and the STN need to be kept in sync!
 * 
 * @author Andreas
 *
 */
public class CSTNTemplateTimeModel extends TCNTemplateTimeModel<LabeledTimePoint, STNEdge> implements TemplateTimeModel
{
 
  private CSTN baseCstnu;

  public CSTNTemplateTimeModel(Template template, CSTN cstnu, Collection<NodeMapping<LabeledTimePoint>> nodeMapping,
      LabeledTimePoint creationTimePoint, LabeledTimePoint startTimePoint, LabeledTimePoint endTimePoint, 
      Map<Integer, List<URI>> updateTriggers)
  {
    super(template, new CSTN2STNProjection(cstnu), nodeMapping, creationTimePoint, startTimePoint, endTimePoint, updateTriggers);
    this.baseCstnu = cstnu;

  }

  @Override
  protected TimeDistance getValue(STNEdge edge)
  {
    if (edge == null)
      return DefaultTimeDistance.POSITIVE_INFINITE_TIME_DISTANCE;
    TimeDistance value = edge.getValue().getValue();

    return value;
  }

  public CSTN getBaseTimeModel()
  {
    return this.baseCstnu;
  }


}
