package de.aristaflow.adept2.model.timemodel.tcn.cstnImpl;

import de.aristaflow.adept2.model.common.Configuration;
import de.aristaflow.adept2.model.timemodel.ChangeSet;
import de.aristaflow.adept2.model.timemodel.TimeModel;
import de.aristaflow.adept2.model.timemodel.TimeModelSolver;
import de.aristaflow.adept2.model.timemodel.defaultimplementation.Triangle;
import de.aristaflow.adept2.model.timemodel.tcn.ChangeableCSTN;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledEdge;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledValueSet;
import de.aristaflow.adept2.model.timemodel.tcn.TCNInconsistencyException;
import de.aristaflow.adept2.util.Tuple;
import de.aristaflow.adept2.util.types.Triple;

public class DCCSTNTemplateTimeModelSolver implements TimeModelSolver
{

//  LabelBasedPC2Solver<LabeledEdge> pc2Solver = new LabelBasedPC2Solver<LabeledEdge>();
  private LabelBasedPC2Solver dcSolver = new LabelBasedPC2Solver();
  
  public void solve(TimeModel timeModel) throws TCNInconsistencyException, InterruptedException
  {
    if (timeModel instanceof CSTNTemplateTimeModel)
    {
      CSTNTemplateTimeModel cstnTimeModel = (CSTNTemplateTimeModel) timeModel;
      solve(cstnTimeModel);
      return;
    }
    if (timeModel instanceof CSTNInstanceTimeModel)
    {
      CSTNInstanceTimeModel cstnTimeModel = (CSTNInstanceTimeModel) timeModel;
      solve(cstnTimeModel);
      return;
    }
    throw new IllegalArgumentException();
  }
  
  public void solve(CSTNTemplateTimeModel timeModel) throws TCNInconsistencyException, InterruptedException
  {
    ChangeableCSTN cstnu = (ChangeableCSTN) timeModel.getBaseTimeModel();
    //TCN<LabeledNode,LabeledEdge> stn = timeModel.getBaseTCN();
    
    // If PC2Solver fails dcSolver will fail as well
    //stn = pc2Solver.solve(stn);
//    CSTN updatedCSTN = 
    dcSolver.solve(cstnu);
    
//    CstnuCStnProjection projection = new CstnuCStnProjection(updatedCSTN, false);
//    
//    pc2Solver.solve(projection);
    //timeModel.updateCstnuStnProjection(projection);
  }
  

  public void solve(CSTNInstanceTimeModel timeModel) throws TCNInconsistencyException, InterruptedException
  {
    solve(timeModel, null);
  }
  
  public void solve(
      CSTNInstanceTimeModel timeModel,
      ChangeSet<LabeledEdge, LabeledValueSet, Triangle<LabeledTimePoint>> changeSet) throws TCNInconsistencyException, InterruptedException
  {
    ChangeableCSTN cstnu = (ChangeableCSTN) timeModel.getBaseTimeModel();

    try
    {
      dcSolver.solve(cstnu, changeSet);
    }
    catch (TCNInconsistencyException e1)
    {
      throw e1;
    }   
    

  }



}
