package de.aristaflow.adept2.model.timemodel.tcn.cstnuImpl;

import de.aristaflow.adept2.model.timemodel.tcn.ChangeableCSTN;
import de.aristaflow.adept2.model.timemodel.tcn.ChangeableCSTNU;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledEdge;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledValue;
import de.aristaflow.adept2.model.timemodel.tcn.cstnImpl.AbstractCSTNProjection;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.ContingentLabeledValue;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.DefaultLabeledEdge;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.DefaultLabeledValue;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.DefaultLabeledValueSet;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.ContingentLabeledValue.ConstraintCase;

public class CSTNUAllMaxProjection extends AbstractCSTNProjection implements ChangeableCSTN
{


  public CSTNUAllMaxProjection(ChangeableCSTNU cstnu)
  {
    super(cstnu, false);
  }


  @Override
  protected LabeledEdge transformEdge(LabeledTimePoint from, LabeledTimePoint to, LabeledEdge edge)
  {
    if (edge.isContingentDuration())
    {
      LabeledValue label = null;
      
      assert edge.getValue().getLabeledValues().size() == 1;
      
      ContingentLabeledValue cl = (ContingentLabeledValue) edge.getValue().getLabeledValues().iterator().next();

      if (ConstraintCase.UPPERCASE.equals(cl.getCase()))
      {
        label = new DefaultLabeledValue(cl.getLabel(), cl.getContingentValue());
      }
      else
      {
        LabeledEdge upperCaseEdge = getBaseTCN().getEdge(to, from);
        assert upperCaseEdge != null : "No opposite edge for "+edge;
        assert upperCaseEdge.getValue().getLabeledValues().size() == 1;
        
        ContingentLabeledValue cu = (ContingentLabeledValue) upperCaseEdge.getValue().getLabeledValues().iterator().next();
        assert ConstraintCase.UPPERCASE.equals(cu.getCase());
        
        label = new DefaultLabeledValue(cl.getLabel(), cu.getContingentValue().neg());
      }
      
      return new DefaultLabeledEdge(from, to, new DefaultLabeledValueSet(label), edge.isControlEdge(), edge.isImplicit(), edge.getFlowDirection());
    }
    
    return edge;
  }

  

  public LabeledTimePoint insertTimePoint(LabeledTimePoint timePoint)
  {
    throw new UnsupportedOperationException();
  }


  public void removeTimePoint(LabeledTimePoint timePoint)
  {
    throw new UnsupportedOperationException();
  }




  





}
