package de.aristaflow.adept2.model.timemodel.tcn.cstnuImpl;

import java.util.Collection;
import java.util.List;

import de.aristaflow.adept2.model.timemodel.tcn.ChangeableCSTN;
import de.aristaflow.adept2.model.timemodel.tcn.ChangeableCSTNU;
import de.aristaflow.adept2.model.timemodel.tcn.Label.ChoiceVariable;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.ReductionProjection;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledEdge;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;

public class CSTNUReductionProjection extends ReductionProjection<LabeledTimePoint, LabeledEdge> implements ChangeableCSTNU, ChangeableCSTN
{

  public CSTNUReductionProjection(ChangeableCSTN tcn, Collection<LabeledTimePoint> nodes)
  {
    super(tcn, nodes);
  }
  
  @Override
  public ChangeableCSTNU getBaseTCN()
  {
    return (ChangeableCSTNU) super.getBaseTCN();
  }

  @Override
  public List<ChoiceVariable> getObservations()
  {
    return getBaseTCN().getObservations();
  }

  @Override
  public boolean isControllable()
  {
    return getBaseTCN().isControllable();
  }

  @Override
  public void setControllable()
  {
    getBaseTCN().setControllable();
  }

  @Override
  public LabeledEdge updateContingentConstraint(LabeledEdge edge)
  {
    return getBaseTCN().updateContingentConstraint(edge);
  }

}
