package de.aristaflow.adept2.model.timemodel.tcn.cstnuImpl;

import java.net.URI;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import de.aristaflow.adept2.model.common.timedata.TimeDistance;
import de.aristaflow.adept2.model.processmodel.Template;
import de.aristaflow.adept2.model.timemodel.TemplateTimeModel;
import de.aristaflow.adept2.model.timemodel.tcn.CSTNU;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;
import de.aristaflow.adept2.model.timemodel.tcn.NodeMapping;
import de.aristaflow.adept2.model.timemodel.tcn.TCNTemplateTimeModel;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.STNEdge;

/**
 * NOTE that the CSTNU and the STN need to be kept in sync!
 * 
 * @author Andreas
 *
 */
public class CSTNUTemplateTimeModel extends TCNTemplateTimeModel<LabeledTimePoint, STNEdge> implements TemplateTimeModel
{
 
  protected CSTNU baseCstnu;

  public CSTNUTemplateTimeModel(Template template, CSTNU cstnu, Collection<NodeMapping<LabeledTimePoint>> nodeMapping,
      LabeledTimePoint processCreationNode, LabeledTimePoint processStartNode, LabeledTimePoint processEndNode, 
      Map<Integer, List<URI>> updateTriggers)
  {
    super(template, new CSTNU2STNProjection(cstnu), nodeMapping, processCreationNode, processStartNode, 
          processEndNode, updateTriggers);
    this.baseCstnu = cstnu;

  }

  @Override
  protected TimeDistance getValue(STNEdge edge)
  {
    TimeDistance value = edge.getValue().getValue();

    return value;
  }

  public CSTNU getBaseTimeModel()
  {
    return this.baseCstnu;
  }



}
