//package de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation;
//
//import java.util.ArrayList;
//import java.util.Collection;
//import java.util.HashMap;
//import java.util.HashSet;
//import java.util.Iterator;
//import java.util.LinkedHashMap;
//import java.util.List;
//import java.util.ListIterator;
//import java.util.Map;
//import java.util.Set;
//import java.util.logging.Level;
//
//import de.aristaflow.adept2.model.timemodel.ChangeSet;
//import de.aristaflow.adept2.model.timemodel.ExtendedChangeSet;
//import de.aristaflow.adept2.model.timemodel.defaultimplementation.DefaultChangeEntry;
//import de.aristaflow.adept2.model.timemodel.tcn.ConstraintDependencyGraph;
//import de.aristaflow.adept2.model.timemodel.tcn.ConstraintValue;
//import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;
//import de.aristaflow.adept2.model.timemodel.tcn.TCN;
//import de.aristaflow.adept2.model.timemodel.tcn.TCNEdge;
//import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.AbstractConstraintDependencyGraph.GraphWrapper;
//import de.aristaflow.adept2.model.timemodel.tools.DirectedGraph;
//import de.aristaflow.adept2.model.timemodel.tools.GraphVisitor;
//import de.aristaflow.adept2.util.Tuple;
//import de.aristaflow.adept2.util.types.Triple;
//
//public class ChangeSetConstraintDependencyGraph<E extends TCNEdge<LabeledTimePoint, T>, T extends ConstraintValue> 
//implements ExtendedChangeSet<E,T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>, ConstraintDependencyGraph<E>
//{
//  
//  protected LinkedHashMap<E, ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>> log = new LinkedHashMap<E, ChangeEntry<E,T,Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>>();
//  protected Map<E, Set<E>> dependencies = new HashMap<E, Set<E>>();
//  protected Level debugLevel = Level.OFF;
//  
//  /* (non-Javadoc)
//   * @see de.aristaflow.adept2.model.timemodel.defaultimplementation.ConstraintDependencyGraph#visit(de.aristaflow.adept2.model.timemodel.tools.DirectedGraph.GraphVisitor)
//   */
//  @Override
//  public void visit(GraphVisitor<Object, Object> visitor)
//  {
//    
//    DirectedGraph<Object, Object> graph = new GraphWrapper<E>(this);
//    visitor.discoverGraph(graph);
//    
//  
//    Iterator<ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>> history = iterator();
//    
//  
//    
//    for (; history.hasNext(); )
//    {
//      DefaultChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>> entry = (DefaultChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>) history.next();
//  
//      
//      visitor.discoverVertex(entry.getElement());
//  
//      Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint> causedBy = entry.getCausedBy();
//      
//      if (causedBy != null)
//      {
//        E parent1 = causedBy.getFirst();
//        //visitor.discoverVertex(parent1);
//        //visitor.finishVertex(parent1);
//        visitor.discoverEdge(parent1, entry.getElement(), parent1.getValue());
//        visitor.finishEdge(parent1, entry.getElement(), parent1.getValue());
//  
//        E parent2 = causedBy.getSecond();
//        //visitor.discoverVertex(parent2);
//        //visitor.finishVertex(parent2);
//        visitor.discoverEdge(parent2, entry.getElement(), parent2.getValue());
//        visitor.finishEdge(parent2, entry.getElement(), parent2.getValue());
//      }
//  
//      visitor.finishVertex(entry.getElement());
//    }
//    
//    
//    visitor.finishGraph(graph);
//    
//  }
//
//  public Iterator<ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>> iterator()
//  {
//    List<ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>> list = new ArrayList<ChangeSet.ChangeEntry<E,T,Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>>(this.log.values());
//    Iterator<ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>> iterator = list.listIterator();
//    return iterator;
//  }
//  
//  public ChangeSetConstraintDependencyGraph(TCN<?, E> tcn)
//  {
//    Collection<E> edges = tcn.getEdges();
//    
//    for (E edge : edges)
//    {
//      logChange(edge, null, edge.getValue(), null, "Initial");
//    }
//  }
//  
//  public void logHiddenChange(E element, T oldValue, T newValue, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint> causedBy,
//      String reason)
//  {
//    //
//  }
//
//  public void logChange(E element, T oldValue, T newValue, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint> causedBy,
//      String reason)
//  {
//    ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>> changeEntry = new DefaultChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>(element, oldValue, newValue, causedBy, reason);
//    logChange(changeEntry);
//  }
//
//
//
//  private void logChange(ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>> changeEntry)
//  {
//    debug(Level.FINE, "Logging change %s", changeEntry);
//    
//    log.remove(changeEntry.getElement());
//    purgeDependent(changeEntry.getElement());
//    
//    log.put(changeEntry.getElement(), changeEntry);
//       
//    if (changeEntry.getCausedBy() != null)
//    {
//      addDependency(changeEntry.getCausedBy().getFirst(), changeEntry.getElement());
//      addDependency(changeEntry.getCausedBy().getSecond(), changeEntry.getElement());
//    }
//  }
//
//
//
//  private void purgeDependent(E element)
//  {
//    Set<E> dependency = dependencies.remove(element);
//    
//    if (dependency != null)
//    {
//      debug(Level.FINER, "Purging change %s", element);
//      for (E d : dependency)
//      {
//        log.remove(d);
//        purgeDependent(d);
//      }
//    }
//    
//  }
//
//  private void addDependency(E element, E dependency)
//  {
//    for (Set<E> l : dependencies.values())
//    {
//      l.remove(dependency);
//    }
//    
//    Set<E> list = dependencies.get(element);
//    if (list == null)
//    {
//      list = new HashSet<E>();
//      dependencies.put(element, list);
//    }
//    list.add(dependency);
//  }
//
//  public void logChange(E element, T oldValue, T newValue, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint> causedBy)
//  {
//    logChange(element, oldValue, newValue, causedBy, null);
//  }
//  
//  public boolean hasChange(E element)
//  {
//    return log.containsKey(element);
//  }
//
//  public Iterator<ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>> getHistory()
//  {
//    List<ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>> list = new ArrayList<ChangeSet.ChangeEntry<E,T,Tuple<E,E>>>(this.log.values());
//    Iterator<ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>> iterator = list.listIterator(list.size());
//    final ListIterator<ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>> listIterator = (ListIterator<ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>>) iterator;
//    //listIterator
//    return new Iterator<ChangeEntry<E,T,Tuple<E,E>>>()
//    {
//      public boolean hasNext() {
//        return listIterator.hasPrevious();
//      }
//  
//      public ChangeEntry<E,T,Tuple<E,E>> next() {
//          return listIterator.previous();
//      }
//  
//      public void remove() {
//          listIterator.remove();
//      }
//    }; 
//  }
//
//
//
//
//  
//  public static <E extends TCNEdge<?, T>, T extends ConstraintValue> ChangeSetConstraintDependencyGraph<E, T> convert(
//      TCN<?, E> tcn, ChangeSet<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>> changeSet)
//  {
//    ChangeSetConstraintDependencyGraph<E, T> graph = new ChangeSetConstraintDependencyGraph<E, T>(tcn);
//
//    Iterator<ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>> iterator = changeSet.iterator();
//
//    for (ChangeEntry<E, T, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>> e; iterator.hasNext();)
//    {
//      e = iterator.next();
//      graph.logChange(e);
//    }
//
//    return graph;
//
//  }
//
//  
//  /* (non-Javadoc)
//   * @see de.aristaflow.adept2.model.timemodel.defaultimplementation.ConstraintDependencyGraph#getVertices()
//   */
//  @Override
//  public Collection<E> getVertices()
//  {
//    return log.keySet();
//  }
//
//  /* (non-Javadoc)
//   * @see de.aristaflow.adept2.model.timemodel.defaultimplementation.ConstraintDependencyGraph#getEdges()
//   */
//  @Override
//  public Collection<Object> getEdges()
//  {
//    return new ArrayList<Object>(log.values());
//  }
//
//  /* (non-Javadoc)
//   * @see de.aristaflow.adept2.model.timemodel.defaultimplementation.ConstraintDependencyGraph#getEdge(E, E)
//   */
//  @Override
//  public Object getEdge(E from, E to)
//  {
//    // TODO Auto-generated method stub
//    return null;
//  }
//
//  protected void debug(Level logLevel, String message)
//  {
//    if (logLevel.intValue() >= debugLevel.intValue())
//    {
//      System.out.println(message);
//      //logger.log(logLevel, message);    
//    }
//  }
//
//  protected void debug(Level logLevel, String message, Object... params)
//  {
//    debug(logLevel, String.format(message, params));    
//  }
//
//  @Override
//  public String toString()
//  {
//    return log.values().toString();
//  }
//}
