package de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation;

import de.aristaflow.adept2.model.common.timedata.TimeDistance;
import de.aristaflow.adept2.model.timemodel.tcn.SimpleConstraintValue;

public class DefaultConstraintValue implements SimpleConstraintValue//, TimeDistance
{


  private TimeDistance value;

  public DefaultConstraintValue(TimeDistance value)
  {
    assert value != null;
    this.value = value;
  }
  
  public TimeDistance getValue()
  {
    return this.value;
  }
 
  @Override
  public int hashCode()
  {
    return value.hashCode();
  }


  @Override
  public boolean equals(Object obj)
  {
    if (this == obj)
      return true;
    
    if (obj == null)
      return false;
    
    if (obj instanceof DefaultConstraintValue)
    {
      DefaultConstraintValue other = (DefaultConstraintValue) obj;
      if (value == null)
      {
        if (other.value != null)
          return false;
      }
      else if (!value.equals(other.value))
        return false;
      return true;
    } else if (obj instanceof TimeDistance)
    {
      TimeDistance other = (TimeDistance)obj;
      if (value == null)
      {
        return false;
      }
      else if (!value.equals(other))
        return false;
      return true;
    }
    return false;
  }
  

  @Override
  public String toString()
  {
    return value.toString();
  }
  
}
