package de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation;

import de.aristaflow.adept2.model.common.timedata.TimeDistance;
import de.aristaflow.adept2.model.timemodel.tcn.Label;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledValue;

public class DefaultContingentLabeledValueWithContingency extends DefaultContingentLabeledValue implements ContingentLabeledValueWithContingency
{

  public static final String UP_DOWN_ARROW = "\u2195";
  
  private TimeDistance contingency;

  public DefaultContingentLabeledValueWithContingency(Label proposition, ConstraintCase cstnuCase, TimeDistance value,
      LabeledTimePoint trigger, TimeDistance contingentValue, TimeDistance contingency)
  {
    super(proposition, cstnuCase, value, trigger, contingentValue);
    this.contingency = contingency;
  }
  
  public TimeDistance getContingency()
  {
    return this.contingency;
  }

  @Override
  public String toString()
  {
    return super.toString() +UP_DOWN_ARROW+ contingency;
  }



  @Override
  public boolean dominates(LabeledValue other)
  {
    // 
    return super.dominates(other);
  }

  @Override
  public boolean equals(Object obj)
  {
    if (this == obj)
      return true;
    if (!super.equals(obj))
      return false;
    if (!(obj instanceof DefaultContingentLabeledValueWithContingency))
      return false;
    DefaultContingentLabeledValueWithContingency other = (DefaultContingentLabeledValueWithContingency) obj;
    if (contingency == null)
    {
      if (other.contingency != null)
        return false;
    }
    else if (!contingency.equals(other.contingency))
      return false;
    return true;
  }
  
  

}
