package de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation;

import java.util.HashSet;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;

import de.aristaflow.adept2.model.common.timedata.TimeDistance;
import de.aristaflow.adept2.model.common.timedata.defaultimplementation.DefaultTimeDistance;
import de.aristaflow.adept2.model.timemodel.tcn.ChangeableCSTN;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;

public class DijkstraSSSP
{

  public class SetElement implements Comparable<SetElement>
  {
    LabeledTimePoint timePoint;
    TimeDistance value;

    
    public SetElement(LabeledTimePoint timePoint, TimeDistance value)
    {
      this.timePoint = timePoint;
      this.value = value;
    }


    public int compareTo(SetElement o)
    {
      if (timePoint == o.timePoint)
        return 0;
      return this.value.compareTo(o.value);
    }


    @Override
    public int hashCode()
    {
      return this.timePoint.hashCode();
    }
    
    
  }

  public DijkstraSSSP()
  {
  }
  
// TODO
  public void propagate(ChangeableCSTN cstn, LabeledTimePoint source)
  {
    SortedSet<SetElement> queue = new TreeSet<SetElement>();
    queue.add(new SetElement(source, DefaultTimeDistance.ZERO_TIME_DISTANCE));
    Set<LabeledTimePoint> processed = new HashSet<LabeledTimePoint>();
    
    while (!queue.isEmpty())
    {
      SetElement current = queue.first();
      queue.remove(current);
      processed.add(current.timePoint);
      
      for (LabeledTimePoint neighbour : cstn.getTimePoints())
      {
        if (processed.contains(neighbour))
          continue;
        
      }
    }
  }

}
