package de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation;

import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;
import de.aristaflow.adept2.model.timemodel.tcn.SimpleConstraintValue;
import de.aristaflow.adept2.model.timemodel.tcn.TCNEdge;

public class STNEdge implements TCNEdge<LabeledTimePoint, SimpleConstraintValue>, Cloneable
{

  private final LabeledTimePoint from;
  private final LabeledTimePoint to;
  private final SimpleConstraintValue value;
  private final FlowDirection flowDirection;
  private boolean implicit;
  private boolean controlEdge;

  public STNEdge(LabeledTimePoint from, LabeledTimePoint to, SimpleConstraintValue value, boolean controledge, boolean implicit, FlowDirection flowDirection)
  {
    this.from = from;
    this.to = to;
    this.value = value;
    this.controlEdge = controledge;
    this.implicit = implicit;
    this.flowDirection = flowDirection;
  }
  
  @Override
  public LabeledTimePoint getSourceNode()
  {
    return from;
  }

  @Override
  public LabeledTimePoint getTargetNode()
  {
    return to;
  }
  
  public SimpleConstraintValue getValue()
  {
    return value;
  }
  
  @Override
  public STNEdge clone()
  {
    return this;
  }

  @Override
  public String toString()
  {
    return from+" -["+value.toString()+"]-> "+to;
  }

  @Override
  public FlowDirection getFlowDirection()
  {
    return flowDirection;
  }

  @Override
  public boolean isControlEdge()
  {
    return controlEdge;
  }

  @Override
  public boolean isImplicit()
  {
    return implicit;
  }


}
