package de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation;

import java.util.Collection;

import de.aristaflow.adept2.model.timemodel.tcn.ChangeableSTN;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;
import de.aristaflow.adept2.model.timemodel.tcn.STN;
import de.aristaflow.adept2.model.timemodel.tcn.SimpleConstraintValue;

public class SimpleSTN extends AbstractTCN<LabeledTimePoint, SimpleConstraintValue, STNEdge> implements STN<LabeledTimePoint, STNEdge>, ChangeableSTN<LabeledTimePoint, STNEdge>
{

  public SimpleSTN(Collection<LabeledTimePoint> nodes,
      Collection<STNEdge> edges)
  {
    super(nodes, edges);
  }

  @Override
  public LabeledTimePoint getTimeBaseEvent()
  {
    return TIMEBASE_NODE;
  }
  
  @Override
  protected boolean doCheckConsistency(STNEdge edge1, STNEdge edge2)
  {
    
    SimpleConstraintValue value1 = edge1.getValue();
    SimpleConstraintValue value2 = edge2.getValue();
    
    if (value1.getValue().compareTo(value2.getValue().neg()) < 0)
      throw new IllegalStateException();
    return true;
  }

  @Override
  public void init()
  {
    // 
  }

  @Override
  protected boolean doCheckConsistency(LabeledTimePoint node)
  {
    return true;
  }

  @Override
  public STN<LabeledTimePoint, STNEdge> clone()
  {
    // Everything is immutable except the STN itself
    return new SimpleSTN(getTimePoints(), getEdges());
  }


  
}
