package de.aristaflow.adept2.model.timemodel.tools;

import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.Queue;

public class DuplicateFreeQueue<P> extends LinkedHashSet<P>
    implements Queue<P>
{
  /**
     * 
     */
  private static final long serialVersionUID = 1L;

  public DuplicateFreeQueue()
  {
    super();
  }
  
  public DuplicateFreeQueue(int initialCapacity)
  {
    super(initialCapacity);
  }


  public P element()
  {
    return this.iterator().next();
  }

  public boolean offer(P o)
  {
    this.add(o);
    return true;
  }

  public P peek()
  {
    if (this.isEmpty())
    {
      return null;
    }
    return element();
  }

  public P poll()
  {
    if (this.isEmpty())
    {
      return null;
    }

    return remove();
  }

  public P remove()
  {
    Iterator<P> iterator = this.iterator();
    P next = iterator.next();
    iterator.remove();

    return next;
  }
}