package de.aristaflow.adept2;

import java.util.ArrayList;
import java.util.List;

import org.junit.runner.RunWith;
import org.junit.runners.Suite;
import org.junit.runners.model.InitializationError;

import de.aristaflow.adept2.core.changeoperations.ExtractSubprocessTest;

@RunWith(de.aristaflow.adept2.ExternalTests.DynamicSuite.class)
public class ExternalTests
{
  
  public static final class DynamicSuite extends Suite {

    public DynamicSuite(Class<?> setupClass) throws InitializationError {
       super(setupClass, ExternalTests.suite());
    }
    
    
  }



  public static Class<?>[] suite() {
    
    System.setProperty("arflow.confdir", "../de.aristaflow.adept2.adept2plugin/conf/test");
    
    List<Class<?>> clazzes = new ArrayList<Class<?>>(3);
    clazzes.add(ExtractSubprocessTest.class);
    addTestClass(clazzes, "de.aristaflow.adept2.model.timemodel.tcn.graphml.GraphMLImportTest");
    addTestClass(clazzes, "de.aristaflow.adept2.model.timemodel.tcn.graphml.GraphMLExportTest");
    addTestClass(clazzes, "de.aristaflow.adept2.model.timemodel.tcn.verona.VeronaTestCases");
    
    return clazzes.toArray(new Class[clazzes.size()]);
  }



  private static void addTestClass(List<Class<?>> clazzes, String className)
  {
    Class<?> clazz = getTestClass(className);
    if (clazz != null)
      clazzes.add(clazz);
  }



  private static Class<?> getTestClass(String className)
  {
    Class<?> clazz = null;
    try
    {
      clazz = Class.forName(className);
    }
    catch (ClassNotFoundException e)
    {
//      e.printStackTrace();
    }
    return clazz;
  }
}
