package de.aristaflow.adept2.model.processmodel.simulator;

import java.util.Random;

public class GaussianDistribution implements Distribution
{
  
  Random random = new Random();

  public long drawRandom(long minDuration, long maxDuration)
  {
    double seed = (random.nextGaussian()+1)/2;
   
    return Math.abs((long)(minDuration + seed * (maxDuration - minDuration)));
  }

  public int drawRandom(double[] probabilities)
  {
    double seed = Math.random();
    
    int i = 0;
    double sum = probabilities[i++];
    
    
    while (seed > sum && i < probabilities.length)
    {
      sum += probabilities[i++];
    }
    
    return i-1;
  }

}
