package de.aristaflow.adept2.model.processmodel.simulator;

import java.text.SimpleDateFormat;
import java.util.Date;

public class SysoutSimulationCallback implements SimulationCallback
{

  SimpleDateFormat dateFormat = new SimpleDateFormat("HH:mm:ss");
  private long startTime;
  
  public void instanceCreated(long timestamp)
  {
    System.out.println("Instance Created @"+formatTimeStamp(timestamp));
    
  }

  public void instanceStarted(long timestamp)
  {
      System.out.println("Instance Started @"+formatTimeStamp(timestamp));
      startTime = timestamp;
  }

  public void activityStarted(int nodeID, int iteration, long timestamp)
  {
    System.out.println("Activity " +nodeID+":"+iteration+" Started @"+formatTimeStamp(timestamp));
  }

  public void activityFinished(int nodeID, int iteration, long timestamp)
  {
    //System.out.println("Activity " +nodeID+":"+iteration+" Finished @"+formatTimeStamp(timestamp));
  }

  public void activityActivated(int nodeID, int iteration, long timestamp)
  {
    //System.out.println("Activity " +nodeID+":"+iteration+" Activated @"+formatTimeStamp(timestamp));
  }

  String formatTimeStamp(long timestamp)
  {
    Date d = new Date(timestamp);
    return dateFormat.format(d);
  }

  public void activitySkipped(int nodeID, int iteration, long timestamp)
  {
    System.out.println("Activity " +nodeID+":"+iteration+" Skipped @"+formatTimeStamp(timestamp));
  }

  public void instanceFinished(long timestamp)
  {
    System.out.println("Instance Finished @"+formatTimeStamp(timestamp));
    
    long duration = (timestamp-startTime)/1000/60;
    
    System.out.println("Duration: "+duration+"min");
    
  }
  
}
