package de.aristaflow.adept2.model.processmodel.simulator;

import org.junit.BeforeClass;
import org.junit.Test;

import de.aristaflow.adept2.model.processmodel.TemporalTemplate;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.TCNTestTools;
import de.aristaflow.adept2.model.timemodel.templates.TestTemplates;

public class TemplateSimulatorTest
{

  @BeforeClass
  public static void setUpBeforeClass() throws Exception
  {
  }

  @Test
  public void testSimulate()
  {
    basicTestWithTemplate(TestTemplates.simpleTimeTestContingentTestTemplate);
    //basicTestWithTemplate(TestTools.xorAdvancedNotPC2);
    //basicTestWithTemplate(TestTools.xorAndTestTemplate);
    //basicTestWithTemplate(TestTools.nestedLoopTestTemplate);
  }

  private void basicTestWithTemplate(TemporalTemplate template)
  {
    //TCNTestTools.printTemplate(template);
    
    TimeModelSimulationStrategy strategy = new TimeModelSimulationStrategy(template, new UniformDistribution());
    
    TemplateSimulator simulator = new TemplateSimulator(template, strategy);
    
    simulator.setSimulationStrategy(strategy);
    
    simulator.simulate();
  }

}
