package de.aristaflow.adept2.model.processmodel.simulator;

import java.util.Random;

public class UniformDistribution implements Distribution
{

  Random random = new Random();
  
  public long drawRandom(long minDuration, long maxDuration)
  {
    if (maxDuration == Long.MAX_VALUE)
    {
      maxDuration = minDuration + 60*60*24*7; // At most one week 
    }
    
    if (minDuration == maxDuration)
      return minDuration;
    
    double seed = Math.random();
    
    return (long)(minDuration + seed * (maxDuration - minDuration));
  }

  public int drawRandom(double[] probabilities)
  {
    double seed = Math.random();
    
    int i = 0;
    double sum = probabilities[i++];
    
    
    while (seed > sum && i < probabilities.length)
    {
      sum += probabilities[i++];
    }
    
    return i-1;
  }

}
