package de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang;

import org.antlr.v4.runtime.ANTLRInputStream;
import org.antlr.v4.runtime.BailErrorStrategy;
import org.antlr.v4.runtime.CharStream;
import org.antlr.v4.runtime.CommonTokenStream;
import org.antlr.v4.runtime.TokenStream;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.Callang6Parser.CalendarScriptContext;
import de.aristaflow.adept2.model.processmodel.timemodel.schedules.lang.script.CalendarScript;

public class Callang6ParserTest
{

  @BeforeClass
  public static void setUpBeforeClass() throws Exception
  {
  }

  @AfterClass
  public static void tearDownAfterClass() throws Exception
  {
  }

  @Before
  public void setUp() throws Exception
  {
  }

  @After
  public void tearDown() throws Exception
  {
  }

  @Test
  public void test()
  {
    CharStream stream = new ANTLRInputStream("{\n" + 
        "temp1 = 7/cal1:during:cal2:during:cal3;\n" +
        "temp1 = [3,7]/cal1:during:cal2;\n" +
        "while(v:meets:x){" +
        "if(a.during.c){temp1 = 7/cal1:during:cal2;" +
        "return(ok);" +
        "}" +
        "}\n" +
        "return(temp1+temp2);\n" +
        "}");
    Callang6Lexer lexer = new Callang6Lexer(stream);
    TokenStream tokenstream = new CommonTokenStream(lexer);
    Callang6Parser parser = new Callang6Parser(tokenstream);
    parser.setErrorHandler(new BailErrorStrategy());
    CalendarScriptContext c = parser.calendarScript();
    CalendarScript script = c.c;
    System.out.println(script);
    System.out.println("OK ");
    
    stream = new ANTLRInputStream("{\n" + 
        "Test1 = 1/SECONDS:during:MINUTES;" +
        "Test1 = 2/SECONDS:during:HOURS;" +
        "Test1 = 3/SECONDS:during:DAYS;" +
        "Test1 = 5/SECONDS:during:WEEKS;" +
        "Test1 = 6/SECONDS:during:MONTHS;" +
        "Test1 = 7/SECONDS:during:YEARS;" +
        "Test1 = 8/SECONDS:during:DECADES;" +
        "Test1 = 9/SECONDS:during:CENTURY;" +
        
        "Test2 = 1/MINUTES:during:HOURS;" +
        "Test2 = 2/MINUTES:during:DAYS;" +
        "Test2 = 3/MINUTES:during:WEEKS;" +
        "Test2 = 4/MINUTES:during:MONTHS;" +
        "Test2 = 5/MINUTES:during:YEARS;" +
        "Test2 = 6/MINUTES:during:DECADES;" +
        "Test2 = 7/MINUTES:during:CENTURY;" +
        
        "Test3 = 9/HOURS:during:DAYS;" +
        
        "Test4 = 1/DAYS:during:WEEKS;" +
        "Test5 = 7/DAYS:during:MONTHS;" +
        "Test6 = 3/DAYS:during:YEARS;" +
        
        "Test7 = 4/MONTHS:during:YEARS;" +
        
        "Test8 = 5/YEARS:during:DECADES;" +
        
        "Test9 = 6/DECADES:during:CENTURY;" +
        "}");
    lexer = new Callang6Lexer(stream);
    tokenstream = new CommonTokenStream(lexer);
    parser = new Callang6Parser(tokenstream);
    parser.setErrorHandler(new BailErrorStrategy());
    c = parser.calendarScript();
    script = c.c;
    System.out.println(script);
  }

}
