package de.aristaflow.adept2.model.timemodel.tcn.cstnImpl;

import org.junit.BeforeClass;
import org.junit.Test;

import de.aristaflow.adept2.model.processmodel.TemporalTemplate;
import de.aristaflow.adept2.model.timemodel.tcn.ChangeableSTN;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledEdge;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;
import de.aristaflow.adept2.model.timemodel.tcn.STN;
import de.aristaflow.adept2.model.timemodel.tcn.TCNInconsistencyException;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.PC2Solver;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.STNEdge;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.STNTemplateTransformation;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.TCNTestTools;
import de.aristaflow.adept2.model.timemodel.templates.TestTemplates;

public class CSTNTemplateTransformationTest
{

  //private static DotTCNVisitor<LabeledNode, LabeledEdge> visitor;

  @BeforeClass
  public static void setUpBeforeClass() throws Exception
  {
    
//    System.out.println("CSTNTemplateTransformationTest");
//    
//    visitor = new DotTCNVisitor<LabeledNode,LabeledEdge>("CSTNTemplateTransformation");
//    visitor.setLabelProvider(new CSTNUGraphFormatter());
//    visitor.setGraphFormatter(new CSTNUGraphFormatter());
  }

  @Test
  public void testTransform() throws TCNInconsistencyException
  {
    basicTestWithTemplate(TestTemplates.simpleTimeTestContingentTestTemplate);
    basicTestWithTemplate(TestTemplates.simpleTimeTestNonContingentTestTemplate);
  }

  private void basicTestWithTemplate(TemporalTemplate template)
  {
    CSTNTemplateTransformation trafo = new CSTNTemplateTransformation(template, 0);
    STN<LabeledTimePoint,LabeledEdge> cstn = trafo.transform();
    
    TCNTestTools.assertConsistent(cstn);
    
    // TODO implement
  }
  
  @Test
  public void testPC2() throws TCNInconsistencyException, InterruptedException
  {
    testPC2WithTemplate(TestTemplates.simpleTimeTestContingentTestTemplate);
    testPC2WithTemplate(TestTemplates.simpleTimeTestNonContingentTestTemplate);
  }

  private void testPC2WithTemplate(TemporalTemplate template)
      throws TCNInconsistencyException, InterruptedException
  {
    STNTemplateTransformation trafo = new STNTemplateTransformation(template, 0);
    ChangeableSTN<LabeledTimePoint,STNEdge> cstn = (ChangeableSTN<LabeledTimePoint, STNEdge>) trafo.transform();
    
    TCNTestTools.assertConsistent(cstn);

    //cstn.visit(visitor.getInstance("SimpleTimeTest"));
    
    PC2Solver<STNEdge> solver = new PC2Solver<STNEdge>();
    try
    {
      solver.solve(cstn);
    }
    catch (TCNInconsistencyException e)
    {
      //cstn.visit(visitor.getInstance("SimpleTimeTest_Failure")); 
      throw e;
    }

    //cstn.visit(visitor.getInstance("SimpleTimeTest_Minimal"));
  }

}
