package de.aristaflow.adept2.model.timemodel.tcn.cstnuImpl;

import static org.junit.Assert.assertNotNull;

import org.junit.BeforeClass;
import org.junit.Test;

import de.aristaflow.adept2.model.timemodel.InconsistencyException;
import de.aristaflow.adept2.model.timemodel.TemplateTimeModel;
import de.aristaflow.adept2.model.timemodel.TimeModelOperations;
import de.aristaflow.adept2.model.timemodel.TimeModelSolver;
import de.aristaflow.adept2.model.timemodel.tcn.cstnuImpl.CSTNUTimeModelFactory;
import de.aristaflow.adept2.model.timemodel.templates.TestTemplates;

public class CSTNUTimeModelFactoryTest
{

  @BeforeClass
  public static void setUpBeforeClass() throws Exception
  {
    //
  }

  @Test
  public void testCreateTimeModelForTemplate()
  {
    CSTNUTimeModelFactory factory = new CSTNUTimeModelFactory();
    TemplateTimeModel timeModel = factory.createTimeModelForTemplate(TestTemplates.simpleTimeTestContingentTestTemplate);
    assertNotNull(timeModel);
  }

  @Test
  public void testGetTimeModelSolver() throws InconsistencyException, InterruptedException
  {
    CSTNUTimeModelFactory factory = new CSTNUTimeModelFactory();
    TemplateTimeModel timeModel = factory.createTimeModelForTemplate(TestTemplates.simpleTimeTestContingentTestTemplate);
    
    TimeModelSolver solver = factory.getTimeModelSolver(timeModel.getClass());
    
    assertNotNull(solver);
    
    solver.solve(timeModel);
  }

  @Test
  public void testGetTimeModelOperations()
  {
    CSTNUTimeModelFactory factory = new CSTNUTimeModelFactory();
    TimeModelOperations timeModelOperations = factory.getTimeModelOperations();
    assertNotNull(timeModelOperations);
  }

}
