//package de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation;
//
//import static org.junit.Assert.fail;
//
//import java.util.ArrayList;
//import java.util.Collection;
//
//import org.junit.Before;
//import org.junit.BeforeClass;
//import org.junit.Test;
//
//import de.aristaflow.adept2.model.common.timedata.defaultimplementation.DefaultTimeDistance;
//import de.aristaflow.adept2.model.processmodel.TemporalTemplate;
//import de.aristaflow.adept2.model.timemodel.ChangeSet;
//import de.aristaflow.adept2.model.timemodel.defaultimplementation.DefaultChangeSet;
//import de.aristaflow.adept2.model.timemodel.defaultimplementation.DefaultTimeModelOperations;
//import de.aristaflow.adept2.model.timemodel.tcn.ChangeableCSTN;
//import de.aristaflow.adept2.model.timemodel.tcn.ChangeableCSTNU;
//import de.aristaflow.adept2.model.timemodel.tcn.IterationChain;
//import de.aristaflow.adept2.model.timemodel.tcn.Label;
//import de.aristaflow.adept2.model.timemodel.tcn.Label.ChoiceVariable;
//import de.aristaflow.adept2.model.timemodel.tcn.LabeledEdge;
//import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;
//import de.aristaflow.adept2.model.timemodel.tcn.LabeledValueSet;
//import de.aristaflow.adept2.model.timemodel.tcn.NodeInstance;
//import de.aristaflow.adept2.model.timemodel.tcn.NodeMapping;
//import de.aristaflow.adept2.model.timemodel.tcn.TCNInconsistencyException;
//import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.ContingentLabeledValue.ConstraintCase;
//import de.aristaflow.adept2.model.timemodel.templates.TestTemplates;
//import de.aristaflow.adept2.model.timemodel.tools.Graph;
//import de.aristaflow.adept2.tools.dot.AbstractDotGraph;
//import de.aristaflow.adept2.tools.dot.DefaultGraphFormatter;
//import de.aristaflow.adept2.tools.dot.DefaultGraphVisitor;
//import de.aristaflow.adept2.tools.dot.DotGraph;
//import de.aristaflow.adept2.tools.dot.DotGraph.RankDir;
//import de.aristaflow.adept2.tools.dot.DotNode;
//import de.aristaflow.adept2.tools.dot.DotNode.NodeStyle;
//import de.aristaflow.adept2.util.Tuple;
//import de.aristaflow.adept2.util.types.Triple;
//
//public class ChangeSetConstraintDependencyGraphTest
//{
//  
//  private static DefaultTimeModelOperations tmo;
//  private CSTNUDCSolver solver;
//  private static DefaultGraphVisitor<LabeledEdge, Object> visitor;
//
//  @BeforeClass
//  public static void setUpBeforeClass() throws Exception
//  {
//    tmo = new DefaultTimeModelOperations();
//    visitor = new DefaultGraphVisitor<LabeledEdge, Object>(ChangeSetConstraintDependencyGraphTest.class.getSimpleName());
//    visitor.setGraphFormatter(new DefaultGraphFormatter<LabeledEdge, Object>()
//    {
//
//      @Override
//      public void formatVertex(LabeledEdge vertex, DotNode node)
//      {
//        if (!vertex.isImplicit())
//          node.setStyle(NodeStyle.BOLD);
//      }
//
//      @Override
//      public void formatGraph(Graph<LabeledEdge, Object> graph,
//          AbstractDotGraph g)
//      {
//        if (g instanceof DotGraph)
//        {
//          ((DotGraph) g).setRankDir(RankDir.TopBottom);
//        }
//      }
//      
//      
//
//    });
//  }
//
//  
//
//  @Before
//  public void setUp()
//  {
//    solver = new CSTNUDCSolver();
//  }
//  
//  public CSTNUDCSolver getSolver()
//  {
//    return solver;
//  }
//
//  
//  @Test
//  public void testSolveABCEx2() throws TCNInconsistencyException, InterruptedException
//  {
//    Collection<LabeledTimePoint> nodes = new ArrayList<LabeledTimePoint>();
//    Collection<LabeledEdge> edges = new ArrayList<LabeledEdge>();
//
//    int nodeID = 0;
//    IterationChain iterationChain = new IterationChain(nodeID);
//    Label branches = Proposition.EMPTY_PROPOSITION;
//
//    LabeledTimePoint A = new DefaultLabeledNode(new NodeInstance(nodeID++, iterationChain, -1), "A", branches);
//    LabeledTimePoint B = new DefaultLabeledNode(new NodeInstance(nodeID++, iterationChain, -1), "B", branches);
//    LabeledTimePoint C = new DefaultLabeledNode(new NodeInstance(nodeID++, iterationChain, -1), "C", branches);
//    nodes.add(A);
//    nodes.add(B);
//    nodes.add(C);
//
//    long u = 1;
//    long v = 2;
//
//    long x = 1;
//    long y = 2;
//
//    LabeledEdge BC = new DefaultLabeledEdge(
//                                     B,
//                                     C,
//                                     new DefaultLabeledValueSet(new DefaultLabeledValue(branches, tmo
//                                     .secondsToTimeDistance(-u))));
//    LabeledEdge CB = new DefaultLabeledEdge(
//                                     C,
//                                     B,
//                                     new DefaultLabeledValueSet(new DefaultLabeledValue(branches, tmo
//                                     .secondsToTimeDistance(v))));
//
//    LabeledEdge AB = new DefaultLabeledEdge(
//                                     A,
//                                     B,
//                                     new DefaultLabeledValueSet(new CSTNULabeledValue(branches, ConstraintCase.LOWERCASE, tmo
//                                     .secondsToTimeDistance(y), B, tmo
//                                     .secondsToTimeDistance(x))));
//    
//
//    LabeledEdge BA = new DefaultLabeledEdge(
//                                     B,
//                                     A,
//                                     new DefaultLabeledValueSet(new CSTNULabeledValue(branches, ConstraintCase.UPPERCASE, tmo
//                                     .secondsToTimeDistance(-x), B, tmo
//                                     .secondsToTimeDistance(-y))));
//    
//    LabeledEdge AC = new DefaultLabeledEdge(
//                                     A,
//                                     C,
//                                     new DefaultLabeledValueSet(new DefaultLabeledValue(branches, tmo
//                                     .secondsToTimeDistance(50))));
//
//    edges.add(BC);
//    edges.add(CB);
//    edges.add(AB);
//    edges.add(BA);
//    edges.add(AC);
//
//    ChangeableCSTNU cstnu = new DefaultCSTNU(null, nodes, edges,
//                            new ArrayList<NodeMapping<LabeledTimePoint>>(0), new ArrayList<ChoiceVariable>());
//    
//    ChangeSetConstraintDependencyGraph<LabeledEdge, LabeledValueSet> dependencyGraph = new ChangeSetConstraintDependencyGraph<LabeledEdge, LabeledValueSet>(cstnu);
//    ChangeSet<LabeledEdge, LabeledValueSet, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>> changeSet = dependencyGraph;
//       
//    cstnu = getSolver().solve(cstnu, changeSet);
//    
////    TCNTestTools.printCDG(dependencyGraph, this.getClass(), "testSolveABCEx2_Final");
//    
//    CSTNConstraintDependencyGraph graph = new CSTNConstraintDependencyGraph(cstnu);
//    
////    TCNTestTools.printCDG(graph, this.getClass(), "testSolveABCEx2_Final2");
//  }
//
//  
//  @Test (expected=TCNInconsistencyException.class)
//  public void testSolveCuttoff() throws TCNInconsistencyException, InterruptedException
//  {
//    Collection<LabeledTimePoint> nodes = new ArrayList<LabeledTimePoint>();
//    Collection<LabeledEdge> edges = new ArrayList<LabeledEdge>();
//
//    int nodeID = 0;
//    IterationChain iterationChain = new IterationChain(nodeID);
//    Label branches = Proposition.EMPTY_PROPOSITION;
//
//    LabeledTimePoint A = new DefaultLabeledNode(new NodeInstance(nodeID++, iterationChain, -1), "A", branches);
//    LabeledTimePoint B = new DefaultLabeledNode(new NodeInstance(nodeID++, iterationChain, -1), "B", branches);
//    LabeledTimePoint C = new DefaultLabeledNode(new NodeInstance(nodeID++, iterationChain, -1), "C", branches);
//    LabeledTimePoint D = new DefaultLabeledNode(new NodeInstance(nodeID++, iterationChain, -1), "D", branches);
//    LabeledTimePoint E = new DefaultLabeledNode(new NodeInstance(nodeID++, iterationChain, -1), "E", branches);
//    nodes.add(A);
//    nodes.add(B);
//    nodes.add(C);
//    nodes.add(D);
//    nodes.add(E);
//
//    LabeledEdge AB = new DefaultLabeledEdge(
//                                     A,
//                                     B,
//                                     new DefaultLabeledValueSet(new DefaultLabeledValue(branches, tmo
//                                     .secondsToTimeDistance(-2))));
//    LabeledEdge BC = new DefaultLabeledEdge(
//                                     B,
//                                     C,
//                                     new DefaultLabeledValueSet(new CSTNULabeledValue(branches, ConstraintCase.LOWERCASE, DefaultTimeDistance.POSITIVE_INFINITE_TIME_DISTANCE, C, tmo
//                                     .secondsToTimeDistance(1))));
//    
//    LabeledEdge CB = new DefaultLabeledEdge(
//                                     C,
//                                     B,
//                                     new DefaultLabeledValueSet(new CSTNULabeledValue(branches, ConstraintCase.UPPERCASE, DefaultTimeDistance.POSITIVE_INFINITE_TIME_DISTANCE, C, tmo
//                                     .secondsToTimeDistance(-1))));
//    
//    LabeledEdge CD = new DefaultLabeledEdge(
//                                     C,
//                                     D,
//                                     new DefaultLabeledValueSet(new DefaultLabeledValue(branches, tmo
//                                     .secondsToTimeDistance(-1))));
//    LabeledEdge DA = new DefaultLabeledEdge(
//                                     D,
//                                     A,
//                                     new DefaultLabeledValueSet(new CSTNULabeledValue(branches, ConstraintCase.LOWERCASE, DefaultTimeDistance.POSITIVE_INFINITE_TIME_DISTANCE, A, tmo
//                                     .secondsToTimeDistance(1))));
//    LabeledEdge AD = new DefaultLabeledEdge(
//                                     A,
//                                     D,
//                                     new DefaultLabeledValueSet(new CSTNULabeledValue(branches, ConstraintCase.UPPERCASE, DefaultTimeDistance.POSITIVE_INFINITE_TIME_DISTANCE, A, tmo
//                                     .secondsToTimeDistance(-1))));
//    
//    LabeledEdge AE = new DefaultLabeledEdge(
//                                     A,
//                                     E,
//                                     new DefaultLabeledValueSet(new DefaultLabeledValue(branches, tmo
//                                     .secondsToTimeDistance(-1))));
//    edges.add(AB);
//    edges.add(BC);
//    edges.add(CB);
//    edges.add(CD);
//    edges.add(DA);
//    edges.add(AD);
//    edges.add(AE);
//
//    ChangeableCSTNU cstnu = new DefaultCSTNU(null, nodes, edges,
//                            new ArrayList<NodeMapping<LabeledTimePoint>>(0), new ArrayList<ChoiceVariable>());
//
//    
//    ChangeSet<LabeledEdge, LabeledValueSet, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>> changeSet = new DefaultChangeSet<LabeledEdge, LabeledValueSet, Triple<LabeledTimePoint, LabeledTimePoint, LabeledTimePoint>>();
//       
//    try
//    {
//      getSolver().solve((ChangeableCSTNU)cstnu.clone(), changeSet);
//      fail("Network is uncontrollable!");
//    }
//    catch (TCNInconsistencyException e)
//    {
//      ChangeSetConstraintDependencyGraph<LabeledEdge, LabeledValueSet> dependencyGraph = ChangeSetConstraintDependencyGraph.convert(cstnu, changeSet);
////      TCNTestTools.printCDG(dependencyGraph, this.getClass(), "testSolveCuttoff_Final_Dep");
//      
//      ChangeSetGraph<LabeledEdge, LabeledValueSet> tree = new ChangeSetGraph<LabeledEdge, LabeledValueSet>(changeSet);
//      
////      tree.visit(visitor.getInstance("testSolveCuttoff_Final_Graph"));
//      throw e;
//    }
//  }
//  
//  @Test
//  public void testConstraintDependencyGraph() throws TCNInconsistencyException, InterruptedException
//  {
//    TemporalTemplate template = TestTemplates.simpleTimeTestContingentTestTemplate;
//  
//    CSTNTemplateTransformation trafo = createTransformation(template);
//    ChangeableCSTN tcn = (ChangeableCSTN) trafo.transform();
//    
//    //TCNTestTools.printTCN(tcn, this.getClass(), "TCN");
//    
//    LabelBasedPC2Solver solver = new LabelBasedPC2Solver();
//    solver.solve(tcn);
//    
//    CSTNConstraintDependencyGraph cdg = new CSTNConstraintDependencyGraph(tcn);
////    TCNTestTools.printCDG(cdg, this.getClass(), "CDG");
//    
//  }
//  
//
//  protected CSTNTemplateTransformation createTransformation(TemporalTemplate template)
//  {
//    CSTNTemplateTransformation trafo = new CSTNTemplateTransformation(template,
//                                                                      0);
//    return trafo;
//  }
//}
