package de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation;

import static org.junit.Assert.*;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

import org.junit.Test;

public class ObservationBindingTest
{

  @Test
  public void testObservationBinding() throws Exception
  {
    Observation observation = mock(Observation.class);
    when(observation.getOptions()).thenReturn(2);
    
    ObservationBinding test = new ObservationBinding(observation, 1, 0);
    test = new ObservationBinding(observation, 1, 1);
    try
    {
      test = new ObservationBinding(observation, 1, 2);
      fail();
    }
    catch (IllegalArgumentException e)
    {
      // 
    }
    
    try
    {
      test = new ObservationBinding(observation, 1, -1);
      fail();
    }
    catch (IllegalArgumentException e)
    {
      // 
    }
    
    test = new ObservationBinding(observation, 4, 1);
    assertTrue(test.getVariable() == observation);
    assertEquals(1, test.getValue());
    assertEquals(4, test.getEdgeCode());
  }

  @Test
  public void testGetValue() throws Exception
  {
    Observation observation = mock(Observation.class);
    when(observation.getOptions()).thenReturn(2);
    
    ObservationBinding test = new ObservationBinding(observation, 1, 0);
    assertEquals(0, test.getValue());
    
    test = new ObservationBinding(observation, 4, 1);
    assertTrue(test.getVariable() == observation);
    assertEquals(1, test.getValue());

  }

  @Test
  public void testGetVariable() throws Exception
  {
    Observation observation = mock(Observation.class);
    when(observation.getOptions()).thenReturn(2);
    
    ObservationBinding test = new ObservationBinding(observation, 1, 0);
    assertTrue(test.getVariable() == observation);
  }

  @Test
  public void testGetEdgeCode() throws Exception
  {
    Observation observation = mock(Observation.class);
    when(observation.getOptions()).thenReturn(2);
    
    ObservationBinding test = new ObservationBinding(observation, 4, 1);
    assertEquals(4, test.getEdgeCode());
    test = new ObservationBinding(observation, 2, 1);
    assertEquals(2, test.getEdgeCode());
    test = new ObservationBinding(observation, -1, 1);
    assertEquals(-1, test.getEdgeCode());
  }

}
