package de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation;

import java.io.IOException;

import org.junit.Before;
import org.junit.Test;

import de.aristaflow.adept2.model.processmodel.TemporalTemplate;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;
import de.aristaflow.adept2.model.timemodel.tcn.SimpleConstraintValue;
import de.aristaflow.adept2.model.timemodel.tcn.TCNInconsistencyException;
import de.aristaflow.adept2.model.timemodel.tcn.TCNTransformation;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.PC2Solver;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.STNEdge;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.STNTemplateTransformation;
import de.aristaflow.adept2.model.timemodel.templates.TestTemplates;
import de.aristaflow.adept2.util.xml.VersionException;
import de.aristaflow.adept2.util.xml.XMLFormatException;



public class PC2SolverTest extends AbstractPC2SolverTest<SimpleConstraintValue, STNEdge>
{

  private PC2Solver<STNEdge> solver;


  
  @Before
  public void setUp()
  {
    solver = new PC2Solver<STNEdge>();
  }

  @Override
  public PC2Solver<STNEdge> getSolver()
  {
    return solver;
  }



  
  @Test (expected = TCNInconsistencyException.class)
  public void testSimpleXOR() throws TCNInconsistencyException, InterruptedException
  {  
    // This template cannot be solved using a standard PC2 solver!
    basicTestWithTemplate(TestTemplates.xorAdvancedNotPC2TestTemplate);
  }

  

  

  
  @Test
  public void testCoopIS13() throws VersionException, XMLFormatException,
      IOException, TCNInconsistencyException, InterruptedException
  {
    TemporalTemplate template = TestTemplates.coopIS13TestTemplate;

    basicTestWithTemplate(template);
  }

  @Override
  protected TCNTransformation<LabeledTimePoint, STNEdge> createTransformation(TemporalTemplate template)
  {
    return new STNTemplateTransformation(template);
  }


}
