package de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation;

import java.util.Map;

import org.apache.commons.collections.map.HashedMap;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.aristaflow.adept2.model.common.timedata.defaultimplementation.DefaultTimeDistance;
import de.aristaflow.adept2.model.timemodel.tcn.CSTNU;
import de.aristaflow.adept2.model.timemodel.tcn.IterationChain;
import de.aristaflow.adept2.model.timemodel.tcn.Label;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledTimePoint;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledValue;
import de.aristaflow.adept2.model.timemodel.tcn.LabeledValueSet;
import de.aristaflow.adept2.model.timemodel.tcn.NodeInstance;
import de.aristaflow.adept2.model.timemodel.tcn.defaultimplementation.ContingentLabeledValue.ConstraintCase;

public class TCNTestToolsTest
{

  @BeforeClass
  public static void setUpBeforeClass() throws Exception
  {
  }

  @AfterClass
  public static void tearDownAfterClass() throws Exception
  {
  }

  @Before
  public void setUp() throws Exception
  {
  }

  @After
  public void tearDown() throws Exception
  {
  }
  
  @Test
  public void testNormalizeLabeledValueSetMap()
  {
    Map<Label, LabeledValue> map = new HashedMap();
    
    LabeledValue v = new DefaultLabeledValue(Proposition.EMPTY_PROPOSITION, new DefaultTimeDistance(1, 0, 0, 0, 0));
    map.put(v.getLabel(), v);
    
    IterationChain iteration = new IterationChain(0);
    DefaultObservationTimePoint A = new DefaultObservationTimePoint(new NodeInstance(0, iteration, 0), "A", Proposition.EMPTY_PROPOSITION, new long[]{0, 1});
    LabeledTimePoint N9 = new DefaultLabeledNode(new NodeInstance(1, iteration, 0), "N9", Proposition.EMPTY_PROPOSITION);
    
    Observation obsA = new Observation(A, 2);
    Proposition a1 = new Proposition(new ObservationBinding(obsA, 0, 0));
    Proposition a2 = new Proposition(new ObservationBinding(obsA, 1, 1));
    
    
    v = new DefaultContingentLabeledValue(a2, ConstraintCase.UPPERCASE, DefaultTimeDistance.POSITIVE_INFINITE_TIME_DISTANCE, N9, new DefaultTimeDistance(3, 0, 0, 0, 0));
    map.put(v.getLabel(), v);
    
    v = new DefaultContingentLabeledValue(a1, ConstraintCase.UPPERCASE, DefaultTimeDistance.POSITIVE_INFINITE_TIME_DISTANCE, N9, new DefaultTimeDistance(5, 0, 0, 0, 0));
    map.put(v.getLabel(), v);
    
    
    System.out.println(map.values());
    
    Map<Label, LabeledValue> actual = TCNTestTools.normalizeLabeledValueSet(CSTNU.class, map);
    System.out.println(actual.values());
  }

}
